#line 2 "src/src_liblistserv_la-content_filter.c"
#line 2 "content_filter.l"

/*
   Copyright 2009, 2010 Free Software Foundation, Inc.


   This file is part of liblistserv.

   liblistserv is free software: you can redistribute it and/or
   modify it under the terms of the GNU General Public License as
   published by the Free Software Foundation, either version 3 of the
   License, or (at your option) any later version.

   liblistserv is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see
   `http://www.gnu.org/licenses/'.
 */

/*
 * YYSTYPE[0] contians the header-field, "Header" or "Text"
 * YYSTYPE[1] contains the string to be searched for, in case of : (contains)
 * match, the text is surrounded by '*'
 * YYSTYPE[2] is NULL or the parameter of Reject/Discard
*/
#define ACTION_REJECT   'R'
#define ACTION_ALLOW    'A'
#define ACTION_MODERATE 'M'
#define ACTION_DISCARD  'D'
#define YYSTYPE         char**



#line 40 "src/src_liblistserv_la-content_filter.c"

#define  YY_INT_ALIGNED long int

/* A lexical scanner generated by flex */

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 5
#define YY_FLEX_SUBMINOR_VERSION 35
#if YY_FLEX_SUBMINOR_VERSION > 0
#define FLEX_BETA
#endif

/* First, we deal with  platform-specific or compiler-specific issues. */

/* begin standard C headers. */
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>

/* end standard C headers. */

/* flex integer type definitions */

#ifndef FLEXINT_H
#define FLEXINT_H

/* C99 systems have <inttypes.h>. Non-C99 systems may or may not. */

#if defined (__STDC_VERSION__) && __STDC_VERSION__ >= 199901L

/* C99 says to define __STDC_LIMIT_MACROS before including stdint.h,
 * if you want the limit (max/min) macros for int types. 
 */
#ifndef __STDC_LIMIT_MACROS
#define __STDC_LIMIT_MACROS 1
#endif

#include <inttypes.h>
typedef int8_t flex_int8_t;
typedef uint8_t flex_uint8_t;
typedef int16_t flex_int16_t;
typedef uint16_t flex_uint16_t;
typedef int32_t flex_int32_t;
typedef uint32_t flex_uint32_t;
#else
typedef signed char flex_int8_t;
typedef short int flex_int16_t;
typedef int flex_int32_t;
typedef unsigned char flex_uint8_t; 
typedef unsigned short int flex_uint16_t;
typedef unsigned int flex_uint32_t;
#endif /* ! C99 */

/* Limits of integral types. */
#ifndef INT8_MIN
#define INT8_MIN               (-128)
#endif
#ifndef INT16_MIN
#define INT16_MIN              (-32767-1)
#endif
#ifndef INT32_MIN
#define INT32_MIN              (-2147483647-1)
#endif
#ifndef INT8_MAX
#define INT8_MAX               (127)
#endif
#ifndef INT16_MAX
#define INT16_MAX              (32767)
#endif
#ifndef INT32_MAX
#define INT32_MAX              (2147483647)
#endif
#ifndef UINT8_MAX
#define UINT8_MAX              (255U)
#endif
#ifndef UINT16_MAX
#define UINT16_MAX             (65535U)
#endif
#ifndef UINT32_MAX
#define UINT32_MAX             (4294967295U)
#endif

#endif /* ! FLEXINT_H */

#ifdef __cplusplus

/* The "const" storage-class-modifier is valid. */
#define YY_USE_CONST

#else	/* ! __cplusplus */

/* C99 requires __STDC__ to be defined as 1. */
#if defined (__STDC__)

#define YY_USE_CONST

#endif	/* defined (__STDC__) */
#endif	/* ! __cplusplus */

#ifdef YY_USE_CONST
#define yyconst const
#else
#define yyconst
#endif

/* Returned upon end-of-file. */
#define YY_NULL 0

/* Promotes a possibly negative, possibly signed char to an unsigned
 * integer for use as an array index.  If the signed char is negative,
 * we want to instead treat it as an 8-bit unsigned char, hence the
 * double cast.
 */
#define YY_SC_TO_UI(c) ((unsigned int) (unsigned char) c)

/* An opaque pointer. */
#ifndef YY_TYPEDEF_YY_SCANNER_T
#define YY_TYPEDEF_YY_SCANNER_T
typedef void* yyscan_t;
#endif

/* For convenience, these vars (plus the bison vars far below)
   are macros in the reentrant scanner. */
#define yyin yyg->yyin_r
#define yyout yyg->yyout_r
#define yyextra yyg->yyextra_r
#define yyleng yyg->yyleng_r
#define yytext yyg->yytext_r
#define yylineno (YY_CURRENT_BUFFER_LVALUE->yy_bs_lineno)
#define yycolumn (YY_CURRENT_BUFFER_LVALUE->yy_bs_column)
#define yy_flex_debug yyg->yy_flex_debug_r

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN yyg->yy_start = 1 + 2 *

/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START ((yyg->yy_start - 1) / 2)
#define YYSTATE YY_START

/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)

/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE listserv_content_filterrestart(yyin ,yyscanner )

#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#ifndef YY_BUF_SIZE
#define YY_BUF_SIZE 16384
#endif

/* The state buf must be large enough to hold one state per character in the main buffer.
 */
#define YY_STATE_BUF_SIZE   ((YY_BUF_SIZE + 2) * sizeof(yy_state_type))

#ifndef YY_TYPEDEF_YY_BUFFER_STATE
#define YY_TYPEDEF_YY_BUFFER_STATE
typedef struct yy_buffer_state *YY_BUFFER_STATE;
#endif

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2

    #define YY_LESS_LINENO(n)
    
/* Return all but the first "n" matched characters back to the input stream. */
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		*yy_cp = yyg->yy_hold_char; \
		YY_RESTORE_YY_MORE_OFFSET \
		yyg->yy_c_buf_p = yy_cp = yy_bp + yyless_macro_arg - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
		} \
	while ( 0 )

#define unput(c) yyunput( c, yyg->yytext_ptr , yyscanner )

#ifndef YY_TYPEDEF_YY_SIZE_T
#define YY_TYPEDEF_YY_SIZE_T
typedef size_t yy_size_t;
#endif

#ifndef YY_STRUCT_YY_BUFFER_STATE
#define YY_STRUCT_YY_BUFFER_STATE
struct yy_buffer_state
	{
	FILE *yy_input_file;

	char *yy_ch_buf;		/* input buffer */
	char *yy_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	yy_size_t yy_buf_size;

	/* Number of characters read into yy_ch_buf, not including EOB
	 * characters.
	 */
	int yy_n_chars;

	/* Whether we "own" the buffer - i.e., we know we created it,
	 * and can realloc() it to grow it, and should free() it to
	 * delete it.
	 */
	int yy_is_our_buffer;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int yy_is_interactive;

	/* Whether we're considered to be at the beginning of a line.
	 * If so, '^' rules will be active on the next match, otherwise
	 * not.
	 */
	int yy_at_bol;

    int yy_bs_lineno; /**< The line count. */
    int yy_bs_column; /**< The column count. */
    
	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int yy_fill_buffer;

	int yy_buffer_status;

#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via listserv_content_filterrestart()), so that the user can continue scanning by
	 * just pointing yyin at a new input file.
	 */
#define YY_BUFFER_EOF_PENDING 2

	};
#endif /* !YY_STRUCT_YY_BUFFER_STATE */

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 *
 * Returns the top of the stack, or NULL.
 */
#define YY_CURRENT_BUFFER ( yyg->yy_buffer_stack \
                          ? yyg->yy_buffer_stack[yyg->yy_buffer_stack_top] \
                          : NULL)

/* Same as previous macro, but useful when we know that the buffer stack is not
 * NULL or when we need an lvalue. For internal use only.
 */
#define YY_CURRENT_BUFFER_LVALUE yyg->yy_buffer_stack[yyg->yy_buffer_stack_top]

void listserv_content_filterrestart (FILE *input_file ,yyscan_t yyscanner );
void listserv_content_filter_switch_to_buffer (YY_BUFFER_STATE new_buffer ,yyscan_t yyscanner );
YY_BUFFER_STATE listserv_content_filter_create_buffer (FILE *file,int size ,yyscan_t yyscanner );
void listserv_content_filter_delete_buffer (YY_BUFFER_STATE b ,yyscan_t yyscanner );
void listserv_content_filter_flush_buffer (YY_BUFFER_STATE b ,yyscan_t yyscanner );
void listserv_content_filterpush_buffer_state (YY_BUFFER_STATE new_buffer ,yyscan_t yyscanner );
void listserv_content_filterpop_buffer_state (yyscan_t yyscanner );

static void listserv_content_filterensure_buffer_stack (yyscan_t yyscanner );
static void listserv_content_filter_load_buffer_state (yyscan_t yyscanner );
static void listserv_content_filter_init_buffer (YY_BUFFER_STATE b,FILE *file ,yyscan_t yyscanner );

#define YY_FLUSH_BUFFER listserv_content_filter_flush_buffer(YY_CURRENT_BUFFER ,yyscanner)

YY_BUFFER_STATE listserv_content_filter_scan_buffer (char *base,yy_size_t size ,yyscan_t yyscanner );
YY_BUFFER_STATE listserv_content_filter_scan_string (yyconst char *yy_str ,yyscan_t yyscanner );
YY_BUFFER_STATE listserv_content_filter_scan_bytes (yyconst char *bytes,int len ,yyscan_t yyscanner );

void *listserv_content_filteralloc (yy_size_t ,yyscan_t yyscanner );
void *listserv_content_filterrealloc (void *,yy_size_t ,yyscan_t yyscanner );
void listserv_content_filterfree (void * ,yyscan_t yyscanner );

#define yy_new_buffer listserv_content_filter_create_buffer

#define yy_set_interactive(is_interactive) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){ \
        listserv_content_filterensure_buffer_stack (yyscanner); \
		YY_CURRENT_BUFFER_LVALUE =    \
            listserv_content_filter_create_buffer(yyin,YY_BUF_SIZE ,yyscanner); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_is_interactive = is_interactive; \
	}

#define yy_set_bol(at_bol) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){\
        listserv_content_filterensure_buffer_stack (yyscanner); \
		YY_CURRENT_BUFFER_LVALUE =    \
            listserv_content_filter_create_buffer(yyin,YY_BUF_SIZE ,yyscanner); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = at_bol; \
	}

#define YY_AT_BOL() (YY_CURRENT_BUFFER_LVALUE->yy_at_bol)

/* Begin user sect3 */

#define listserv_content_filterwrap(n) 1
#define YY_SKIP_YYWRAP

typedef unsigned char YY_CHAR;

typedef yyconst struct yy_trans_info *yy_state_type;

#define yytext_ptr yytext_r

static yy_state_type yy_get_previous_state (yyscan_t yyscanner );
static yy_state_type yy_try_NUL_trans (yy_state_type current_state  ,yyscan_t yyscanner);
static int yy_get_next_buffer (yyscan_t yyscanner );
static void yy_fatal_error (yyconst char msg[] ,yyscan_t yyscanner );

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up yytext.
 */
#define YY_DO_BEFORE_ACTION \
	yyg->yytext_ptr = yy_bp; \
	yyleng = (size_t) (yy_cp - yy_bp); \
	yyg->yy_hold_char = *yy_cp; \
	*yy_cp = '\0'; \
	yyg->yy_c_buf_p = yy_cp;

#define YY_NUM_RULES 54
#define YY_END_OF_BUFFER 55
struct yy_trans_info
	{
	flex_int32_t yy_verify;
	flex_int32_t yy_nxt;
	};
static yyconst struct yy_trans_info yy_transition[7032] =
    {
 {   0,   0 }, {   0,6776 }, {   0,   0 }, {   0,6774 }, {   1,1032 },
 {   2,1032 }, {   3,1032 }, {   4,1032 }, {   5,1032 }, {   6,1032 },
 {   7,1032 }, {   8,1032 }, {   9,1032 }, {  10,1290 }, {  11,1032 },
 {  12,1032 }, {  13,1032 }, {  14,1032 }, {  15,1032 }, {  16,1032 },
 {  17,1032 }, {  18,1032 }, {  19,1032 }, {  20,1032 }, {  21,1032 },
 {  22,1032 }, {  23,1032 }, {  24,1032 }, {  25,1032 }, {  26,1032 },
 {  27,1032 }, {  28,1032 }, {  29,1032 }, {  30,1032 }, {  31,1032 },
 {  32,1292 }, {  33,1032 }, {  34,1032 }, {  35,1032 }, {  36,1032 },
 {  37,1032 }, {  38,1032 }, {  39,1032 }, {  40,1032 }, {  41,1032 },
 {  42,1032 }, {  43,1032 }, {  44,1032 }, {  45,1032 }, {  46,1032 },

 {  47,1032 }, {  48,1032 }, {  49,1032 }, {  50,1032 }, {  51,1032 },
 {  52,1032 }, {  53,1032 }, {  54,1032 }, {  55,1032 }, {  56,1032 },
 {  57,1032 }, {  58,1292 }, {  59,1032 }, {  60,1032 }, {  61,1032 },
 {  62,1032 }, {  63,1032 }, {  64,1032 }, {  65,1032 }, {  66,1032 },
 {  67,1032 }, {  68,1032 }, {  69,1032 }, {  70,1032 }, {  71,1032 },
 {  72,1032 }, {  73,1032 }, {  74,1032 }, {  75,1032 }, {  76,1032 },
 {  77,1032 }, {  78,1032 }, {  79,1032 }, {  80,1032 }, {  81,1032 },
 {  82,1032 }, {  83,1032 }, {  84,1032 }, {  85,1032 }, {  86,1032 },
 {  87,1032 }, {  88,1032 }, {  89,1032 }, {  90,1032 }, {  91,1032 },
 {  92,1032 }, {  93,1032 }, {  94,1032 }, {  95,1032 }, {  96,1032 },

 {  97,1032 }, {  98,1032 }, {  99,1032 }, { 100,1032 }, { 101,1032 },
 { 102,1032 }, { 103,1032 }, { 104,1032 }, { 105,1032 }, { 106,1032 },
 { 107,1032 }, { 108,1032 }, { 109,1032 }, { 110,1032 }, { 111,1032 },
 { 112,1032 }, { 113,1032 }, { 114,1032 }, { 115,1032 }, { 116,1032 },
 { 117,1032 }, { 118,1032 }, { 119,1032 }, { 120,1032 }, { 121,1032 },
 { 122,1032 }, { 123,1032 }, { 124,1032 }, { 125,1032 }, { 126,1032 },
 { 127,1032 }, { 128,1032 }, { 129,1032 }, { 130,1032 }, { 131,1032 },
 { 132,1032 }, { 133,1032 }, { 134,1032 }, { 135,1032 }, { 136,1032 },
 { 137,1032 }, { 138,1032 }, { 139,1032 }, { 140,1032 }, { 141,1032 },
 { 142,1032 }, { 143,1032 }, { 144,1032 }, { 145,1032 }, { 146,1032 },

 { 147,1032 }, { 148,1032 }, { 149,1032 }, { 150,1032 }, { 151,1032 },
 { 152,1032 }, { 153,1032 }, { 154,1032 }, { 155,1032 }, { 156,1032 },
 { 157,1032 }, { 158,1032 }, { 159,1032 }, { 160,1032 }, { 161,1032 },
 { 162,1032 }, { 163,1032 }, { 164,1032 }, { 165,1032 }, { 166,1032 },
 { 167,1032 }, { 168,1032 }, { 169,1032 }, { 170,1032 }, { 171,1032 },
 { 172,1032 }, { 173,1032 }, { 174,1032 }, { 175,1032 }, { 176,1032 },
 { 177,1032 }, { 178,1032 }, { 179,1032 }, { 180,1032 }, { 181,1032 },
 { 182,1032 }, { 183,1032 }, { 184,1032 }, { 185,1032 }, { 186,1032 },
 { 187,1032 }, { 188,1032 }, { 189,1032 }, { 190,1032 }, { 191,1032 },
 { 192,1032 }, { 193,1032 }, { 194,1032 }, { 195,1032 }, { 196,1032 },

 { 197,1032 }, { 198,1032 }, { 199,1032 }, { 200,1032 }, { 201,1032 },
 { 202,1032 }, { 203,1032 }, { 204,1032 }, { 205,1032 }, { 206,1032 },
 { 207,1032 }, { 208,1032 }, { 209,1032 }, { 210,1032 }, { 211,1032 },
 { 212,1032 }, { 213,1032 }, { 214,1032 }, { 215,1032 }, { 216,1032 },
 { 217,1032 }, { 218,1032 }, { 219,1032 }, { 220,1032 }, { 221,1032 },
 { 222,1032 }, { 223,1032 }, { 224,1032 }, { 225,1032 }, { 226,1032 },
 { 227,1032 }, { 228,1032 }, { 229,1032 }, { 230,1032 }, { 231,1032 },
 { 232,1032 }, { 233,1032 }, { 234,1032 }, { 235,1032 }, { 236,1032 },
 { 237,1032 }, { 238,1032 }, { 239,1032 }, { 240,1032 }, { 241,1032 },
 { 242,1032 }, { 243,1032 }, { 244,1032 }, { 245,1032 }, { 246,1032 },

 { 247,1032 }, { 248,1032 }, { 249,1032 }, { 250,1032 }, { 251,1032 },
 { 252,1032 }, { 253,1032 }, { 254,1032 }, { 255,1032 }, { 256,1032 },
 {   0,   0 }, {   0,6516 }, {   1, 774 }, {   2, 774 }, {   3, 774 },
 {   4, 774 }, {   5, 774 }, {   6, 774 }, {   7, 774 }, {   8, 774 },
 {   9, 774 }, {  10,1032 }, {  11, 774 }, {  12, 774 }, {  13, 774 },
 {  14, 774 }, {  15, 774 }, {  16, 774 }, {  17, 774 }, {  18, 774 },
 {  19, 774 }, {  20, 774 }, {  21, 774 }, {  22, 774 }, {  23, 774 },
 {  24, 774 }, {  25, 774 }, {  26, 774 }, {  27, 774 }, {  28, 774 },
 {  29, 774 }, {  30, 774 }, {  31, 774 }, {  32,1034 }, {  33, 774 },
 {  34, 774 }, {  35, 774 }, {  36, 774 }, {  37, 774 }, {  38, 774 },

 {  39, 774 }, {  40, 774 }, {  41, 774 }, {  42, 774 }, {  43, 774 },
 {  44, 774 }, {  45, 774 }, {  46, 774 }, {  47, 774 }, {  48, 774 },
 {  49, 774 }, {  50, 774 }, {  51, 774 }, {  52, 774 }, {  53, 774 },
 {  54, 774 }, {  55, 774 }, {  56, 774 }, {  57, 774 }, {  58,1034 },
 {  59, 774 }, {  60, 774 }, {  61, 774 }, {  62, 774 }, {  63, 774 },
 {  64, 774 }, {  65, 774 }, {  66, 774 }, {  67, 774 }, {  68, 774 },
 {  69, 774 }, {  70, 774 }, {  71, 774 }, {  72, 774 }, {  73, 774 },
 {  74, 774 }, {  75, 774 }, {  76, 774 }, {  77, 774 }, {  78, 774 },
 {  79, 774 }, {  80, 774 }, {  81, 774 }, {  82, 774 }, {  83, 774 },
 {  84, 774 }, {  85, 774 }, {  86, 774 }, {  87, 774 }, {  88, 774 },

 {  89, 774 }, {  90, 774 }, {  91, 774 }, {  92, 774 }, {  93, 774 },
 {  94, 774 }, {  95, 774 }, {  96, 774 }, {  97, 774 }, {  98, 774 },
 {  99, 774 }, { 100, 774 }, { 101, 774 }, { 102, 774 }, { 103, 774 },
 { 104, 774 }, { 105, 774 }, { 106, 774 }, { 107, 774 }, { 108, 774 },
 { 109, 774 }, { 110, 774 }, { 111, 774 }, { 112, 774 }, { 113, 774 },
 { 114, 774 }, { 115, 774 }, { 116, 774 }, { 117, 774 }, { 118, 774 },
 { 119, 774 }, { 120, 774 }, { 121, 774 }, { 122, 774 }, { 123, 774 },
 { 124, 774 }, { 125, 774 }, { 126, 774 }, { 127, 774 }, { 128, 774 },
 { 129, 774 }, { 130, 774 }, { 131, 774 }, { 132, 774 }, { 133, 774 },
 { 134, 774 }, { 135, 774 }, { 136, 774 }, { 137, 774 }, { 138, 774 },

 { 139, 774 }, { 140, 774 }, { 141, 774 }, { 142, 774 }, { 143, 774 },
 { 144, 774 }, { 145, 774 }, { 146, 774 }, { 147, 774 }, { 148, 774 },
 { 149, 774 }, { 150, 774 }, { 151, 774 }, { 152, 774 }, { 153, 774 },
 { 154, 774 }, { 155, 774 }, { 156, 774 }, { 157, 774 }, { 158, 774 },
 { 159, 774 }, { 160, 774 }, { 161, 774 }, { 162, 774 }, { 163, 774 },
 { 164, 774 }, { 165, 774 }, { 166, 774 }, { 167, 774 }, { 168, 774 },
 { 169, 774 }, { 170, 774 }, { 171, 774 }, { 172, 774 }, { 173, 774 },
 { 174, 774 }, { 175, 774 }, { 176, 774 }, { 177, 774 }, { 178, 774 },
 { 179, 774 }, { 180, 774 }, { 181, 774 }, { 182, 774 }, { 183, 774 },
 { 184, 774 }, { 185, 774 }, { 186, 774 }, { 187, 774 }, { 188, 774 },

 { 189, 774 }, { 190, 774 }, { 191, 774 }, { 192, 774 }, { 193, 774 },
 { 194, 774 }, { 195, 774 }, { 196, 774 }, { 197, 774 }, { 198, 774 },
 { 199, 774 }, { 200, 774 }, { 201, 774 }, { 202, 774 }, { 203, 774 },
 { 204, 774 }, { 205, 774 }, { 206, 774 }, { 207, 774 }, { 208, 774 },
 { 209, 774 }, { 210, 774 }, { 211, 774 }, { 212, 774 }, { 213, 774 },
 { 214, 774 }, { 215, 774 }, { 216, 774 }, { 217, 774 }, { 218, 774 },
 { 219, 774 }, { 220, 774 }, { 221, 774 }, { 222, 774 }, { 223, 774 },
 { 224, 774 }, { 225, 774 }, { 226, 774 }, { 227, 774 }, { 228, 774 },
 { 229, 774 }, { 230, 774 }, { 231, 774 }, { 232, 774 }, { 233, 774 },
 { 234, 774 }, { 235, 774 }, { 236, 774 }, { 237, 774 }, { 238, 774 },

 { 239, 774 }, { 240, 774 }, { 241, 774 }, { 242, 774 }, { 243, 774 },
 { 244, 774 }, { 245, 774 }, { 246, 774 }, { 247, 774 }, { 248, 774 },
 { 249, 774 }, { 250, 774 }, { 251, 774 }, { 252, 774 }, { 253, 774 },
 { 254, 774 }, { 255, 774 }, { 256, 774 }, {   0,   0 }, {   0,6258 },
 {   1,1034 }, {   2,1034 }, {   3,1034 }, {   4,1034 }, {   5,1034 },
 {   6,1034 }, {   7,1034 }, {   8,1034 }, {   9,1034 }, {  10,1036 },
 {  11,1034 }, {  12,1034 }, {  13,1034 }, {  14,1034 }, {  15,1034 },
 {  16,1034 }, {  17,1034 }, {  18,1034 }, {  19,1034 }, {  20,1034 },
 {  21,1034 }, {  22,1034 }, {  23,1034 }, {  24,1034 }, {  25,1034 },
 {  26,1034 }, {  27,1034 }, {  28,1034 }, {  29,1034 }, {  30,1034 },

 {  31,1034 }, {  32,1034 }, {  33,1034 }, {  34,1034 }, {  35,1034 },
 {  36,1034 }, {  37,1034 }, {  38,1034 }, {  39,1034 }, {  40,1034 },
 {  41,1034 }, {  42,1034 }, {  43,1034 }, {  44,1034 }, {  45,1034 },
 {  46,1034 }, {  47,1034 }, {  48,1034 }, {  49,1034 }, {  50,1034 },
 {  51,1034 }, {  52,1034 }, {  53,1034 }, {  54,1034 }, {  55,1034 },
 {  56,1034 }, {  57,1034 }, {  58,1034 }, {  59,1034 }, {  60,1034 },
 {  61,1034 }, {  62,1034 }, {  63,1034 }, {  64,1034 }, {  65,1038 },
 {  66,1034 }, {  67,1034 }, {  68,1034 }, {  69,1034 }, {  70,1034 },
 {  71,1034 }, {  72,1034 }, {  73,1034 }, {  74,1034 }, {  75,1034 },
 {  76,1034 }, {  77,1034 }, {  78,1034 }, {  79,1034 }, {  80,1034 },

 {  81,1034 }, {  82,1034 }, {  83,1034 }, {  84,1034 }, {  85,1034 },
 {  86,1034 }, {  87,1034 }, {  88,1034 }, {  89,1034 }, {  90,1034 },
 {  91,1034 }, {  92,1034 }, {  93,1034 }, {  94,1034 }, {  95,1034 },
 {  96,1034 }, {  97,1038 }, {  98,1034 }, {  99,1034 }, { 100,1034 },
 { 101,1034 }, { 102,1034 }, { 103,1034 }, { 104,1034 }, { 105,1034 },
 { 106,1034 }, { 107,1034 }, { 108,1034 }, { 109,1034 }, { 110,1034 },
 { 111,1034 }, { 112,1034 }, { 113,1034 }, { 114,1034 }, { 115,1034 },
 { 116,1034 }, { 117,1034 }, { 118,1034 }, { 119,1034 }, { 120,1034 },
 { 121,1034 }, { 122,1034 }, { 123,1034 }, { 124,1034 }, { 125,1034 },
 { 126,1034 }, { 127,1034 }, { 128,1034 }, { 129,1034 }, { 130,1034 },

 { 131,1034 }, { 132,1034 }, { 133,1034 }, { 134,1034 }, { 135,1034 },
 { 136,1034 }, { 137,1034 }, { 138,1034 }, { 139,1034 }, { 140,1034 },
 { 141,1034 }, { 142,1034 }, { 143,1034 }, { 144,1034 }, { 145,1034 },
 { 146,1034 }, { 147,1034 }, { 148,1034 }, { 149,1034 }, { 150,1034 },
 { 151,1034 }, { 152,1034 }, { 153,1034 }, { 154,1034 }, { 155,1034 },
 { 156,1034 }, { 157,1034 }, { 158,1034 }, { 159,1034 }, { 160,1034 },
 { 161,1034 }, { 162,1034 }, { 163,1034 }, { 164,1034 }, { 165,1034 },
 { 166,1034 }, { 167,1034 }, { 168,1034 }, { 169,1034 }, { 170,1034 },
 { 171,1034 }, { 172,1034 }, { 173,1034 }, { 174,1034 }, { 175,1034 },
 { 176,1034 }, { 177,1034 }, { 178,1034 }, { 179,1034 }, { 180,1034 },

 { 181,1034 }, { 182,1034 }, { 183,1034 }, { 184,1034 }, { 185,1034 },
 { 186,1034 }, { 187,1034 }, { 188,1034 }, { 189,1034 }, { 190,1034 },
 { 191,1034 }, { 192,1034 }, { 193,1034 }, { 194,1034 }, { 195,1034 },
 { 196,1034 }, { 197,1034 }, { 198,1034 }, { 199,1034 }, { 200,1034 },
 { 201,1034 }, { 202,1034 }, { 203,1034 }, { 204,1034 }, { 205,1034 },
 { 206,1034 }, { 207,1034 }, { 208,1034 }, { 209,1034 }, { 210,1034 },
 { 211,1034 }, { 212,1034 }, { 213,1034 }, { 214,1034 }, { 215,1034 },
 { 216,1034 }, { 217,1034 }, { 218,1034 }, { 219,1034 }, { 220,1034 },
 { 221,1034 }, { 222,1034 }, { 223,1034 }, { 224,1034 }, { 225,1034 },
 { 226,1034 }, { 227,1034 }, { 228,1034 }, { 229,1034 }, { 230,1034 },

 { 231,1034 }, { 232,1034 }, { 233,1034 }, { 234,1034 }, { 235,1034 },
 { 236,1034 }, { 237,1034 }, { 238,1034 }, { 239,1034 }, { 240,1034 },
 { 241,1034 }, { 242,1034 }, { 243,1034 }, { 244,1034 }, { 245,1034 },
 { 246,1034 }, { 247,1034 }, { 248,1034 }, { 249,1034 }, { 250,1034 },
 { 251,1034 }, { 252,1034 }, { 253,1034 }, { 254,1034 }, { 255,1034 },
 { 256,1034 }, {   0,   0 }, {   0,6000 }, {   1, 776 }, {   2, 776 },
 {   3, 776 }, {   4, 776 }, {   5, 776 }, {   6, 776 }, {   7, 776 },
 {   8, 776 }, {   9, 776 }, {  10, 778 }, {  11, 776 }, {  12, 776 },
 {  13, 776 }, {  14, 776 }, {  15, 776 }, {  16, 776 }, {  17, 776 },
 {  18, 776 }, {  19, 776 }, {  20, 776 }, {  21, 776 }, {  22, 776 },

 {  23, 776 }, {  24, 776 }, {  25, 776 }, {  26, 776 }, {  27, 776 },
 {  28, 776 }, {  29, 776 }, {  30, 776 }, {  31, 776 }, {  32, 776 },
 {  33, 776 }, {  34, 776 }, {  35, 776 }, {  36, 776 }, {  37, 776 },
 {  38, 776 }, {  39, 776 }, {  40, 776 }, {  41, 776 }, {  42, 776 },
 {  43, 776 }, {  44, 776 }, {  45, 776 }, {  46, 776 }, {  47, 776 },
 {  48, 776 }, {  49, 776 }, {  50, 776 }, {  51, 776 }, {  52, 776 },
 {  53, 776 }, {  54, 776 }, {  55, 776 }, {  56, 776 }, {  57, 776 },
 {  58, 776 }, {  59, 776 }, {  60, 776 }, {  61, 776 }, {  62, 776 },
 {  63, 776 }, {  64, 776 }, {  65, 780 }, {  66, 776 }, {  67, 776 },
 {  68, 776 }, {  69, 776 }, {  70, 776 }, {  71, 776 }, {  72, 776 },

 {  73, 776 }, {  74, 776 }, {  75, 776 }, {  76, 776 }, {  77, 776 },
 {  78, 776 }, {  79, 776 }, {  80, 776 }, {  81, 776 }, {  82, 776 },
 {  83, 776 }, {  84, 776 }, {  85, 776 }, {  86, 776 }, {  87, 776 },
 {  88, 776 }, {  89, 776 }, {  90, 776 }, {  91, 776 }, {  92, 776 },
 {  93, 776 }, {  94, 776 }, {  95, 776 }, {  96, 776 }, {  97, 780 },
 {  98, 776 }, {  99, 776 }, { 100, 776 }, { 101, 776 }, { 102, 776 },
 { 103, 776 }, { 104, 776 }, { 105, 776 }, { 106, 776 }, { 107, 776 },
 { 108, 776 }, { 109, 776 }, { 110, 776 }, { 111, 776 }, { 112, 776 },
 { 113, 776 }, { 114, 776 }, { 115, 776 }, { 116, 776 }, { 117, 776 },
 { 118, 776 }, { 119, 776 }, { 120, 776 }, { 121, 776 }, { 122, 776 },

 { 123, 776 }, { 124, 776 }, { 125, 776 }, { 126, 776 }, { 127, 776 },
 { 128, 776 }, { 129, 776 }, { 130, 776 }, { 131, 776 }, { 132, 776 },
 { 133, 776 }, { 134, 776 }, { 135, 776 }, { 136, 776 }, { 137, 776 },
 { 138, 776 }, { 139, 776 }, { 140, 776 }, { 141, 776 }, { 142, 776 },
 { 143, 776 }, { 144, 776 }, { 145, 776 }, { 146, 776 }, { 147, 776 },
 { 148, 776 }, { 149, 776 }, { 150, 776 }, { 151, 776 }, { 152, 776 },
 { 153, 776 }, { 154, 776 }, { 155, 776 }, { 156, 776 }, { 157, 776 },
 { 158, 776 }, { 159, 776 }, { 160, 776 }, { 161, 776 }, { 162, 776 },
 { 163, 776 }, { 164, 776 }, { 165, 776 }, { 166, 776 }, { 167, 776 },
 { 168, 776 }, { 169, 776 }, { 170, 776 }, { 171, 776 }, { 172, 776 },

 { 173, 776 }, { 174, 776 }, { 175, 776 }, { 176, 776 }, { 177, 776 },
 { 178, 776 }, { 179, 776 }, { 180, 776 }, { 181, 776 }, { 182, 776 },
 { 183, 776 }, { 184, 776 }, { 185, 776 }, { 186, 776 }, { 187, 776 },
 { 188, 776 }, { 189, 776 }, { 190, 776 }, { 191, 776 }, { 192, 776 },
 { 193, 776 }, { 194, 776 }, { 195, 776 }, { 196, 776 }, { 197, 776 },
 { 198, 776 }, { 199, 776 }, { 200, 776 }, { 201, 776 }, { 202, 776 },
 { 203, 776 }, { 204, 776 }, { 205, 776 }, { 206, 776 }, { 207, 776 },
 { 208, 776 }, { 209, 776 }, { 210, 776 }, { 211, 776 }, { 212, 776 },
 { 213, 776 }, { 214, 776 }, { 215, 776 }, { 216, 776 }, { 217, 776 },
 { 218, 776 }, { 219, 776 }, { 220, 776 }, { 221, 776 }, { 222, 776 },

 { 223, 776 }, { 224, 776 }, { 225, 776 }, { 226, 776 }, { 227, 776 },
 { 228, 776 }, { 229, 776 }, { 230, 776 }, { 231, 776 }, { 232, 776 },
 { 233, 776 }, { 234, 776 }, { 235, 776 }, { 236, 776 }, { 237, 776 },
 { 238, 776 }, { 239, 776 }, { 240, 776 }, { 241, 776 }, { 242, 776 },
 { 243, 776 }, { 244, 776 }, { 245, 776 }, { 246, 776 }, { 247, 776 },
 { 248, 776 }, { 249, 776 }, { 250, 776 }, { 251, 776 }, { 252, 776 },
 { 253, 776 }, { 254, 776 }, { 255, 776 }, { 256, 776 }, {   0,   8 },
 {   0,5742 }, {   1, 623 }, {   2, 623 }, {   3, 623 }, {   4, 623 },
 {   5, 623 }, {   6, 623 }, {   7, 623 }, {   8, 623 }, {   9, 623 },
 {  10, 524 }, {  11, 623 }, {  12, 623 }, {  13, 623 }, {  14, 623 },

 {  15, 623 }, {  16, 623 }, {  17, 623 }, {  18, 623 }, {  19, 623 },
 {  20, 623 }, {  21, 623 }, {  22, 623 }, {  23, 623 }, {  24, 623 },
 {  25, 623 }, {  26, 623 }, {  27, 623 }, {  28, 623 }, {  29, 623 },
 {  30, 623 }, {  31, 623 }, {  32, 526 }, {  33, 623 }, {  34, 623 },
 {  35, 623 }, {  36, 623 }, {  37, 623 }, {  38, 623 }, {  39, 623 },
 {  40, 623 }, {  41, 623 }, {  42, 623 }, {  43, 623 }, {  44, 623 },
 {  45, 623 }, {  46, 623 }, {  47, 623 }, {  48, 623 }, {  49, 623 },
 {  50, 623 }, {  51, 623 }, {  52, 623 }, {  53, 623 }, {  54, 623 },
 {  55, 623 }, {  56, 623 }, {  57, 623 }, {  58, 881 }, {  59, 623 },
 {  60, 623 }, {  61, 623 }, {  62, 623 }, {  63, 623 }, {  64, 623 },

 {  65, 623 }, {  66, 623 }, {  67, 623 }, {  68, 623 }, {  69, 623 },
 {  70, 623 }, {  71, 623 }, {  72, 623 }, {  73, 623 }, {  74, 623 },
 {  75, 623 }, {  76, 623 }, {  77, 623 }, {  78, 623 }, {  79, 623 },
 {  80, 623 }, {  81, 623 }, {  82, 623 }, {  83, 623 }, {  84, 623 },
 {  85, 623 }, {  86, 623 }, {  87, 623 }, {  88, 623 }, {  89, 623 },
 {  90, 623 }, {  91, 623 }, {  92, 623 }, {  93, 623 }, {  94, 623 },
 {  95, 623 }, {  96, 623 }, {  97, 623 }, {  98, 623 }, {  99, 623 },
 { 100, 623 }, { 101, 623 }, { 102, 623 }, { 103, 623 }, { 104, 623 },
 { 105, 623 }, { 106, 623 }, { 107, 623 }, { 108, 623 }, { 109, 623 },
 { 110, 623 }, { 111, 623 }, { 112, 623 }, { 113, 623 }, { 114, 623 },

 { 115, 623 }, { 116, 623 }, { 117, 623 }, { 118, 623 }, { 119, 623 },
 { 120, 623 }, { 121, 623 }, { 122, 623 }, { 123, 623 }, { 124, 623 },
 { 125, 623 }, { 126, 623 }, { 127, 623 }, { 128, 623 }, { 129, 623 },
 { 130, 623 }, { 131, 623 }, { 132, 623 }, { 133, 623 }, { 134, 623 },
 { 135, 623 }, { 136, 623 }, { 137, 623 }, { 138, 623 }, { 139, 623 },
 { 140, 623 }, { 141, 623 }, { 142, 623 }, { 143, 623 }, { 144, 623 },
 { 145, 623 }, { 146, 623 }, { 147, 623 }, { 148, 623 }, { 149, 623 },
 { 150, 623 }, { 151, 623 }, { 152, 623 }, { 153, 623 }, { 154, 623 },
 { 155, 623 }, { 156, 623 }, { 157, 623 }, { 158, 623 }, { 159, 623 },
 { 160, 623 }, { 161, 623 }, { 162, 623 }, { 163, 623 }, { 164, 623 },

 { 165, 623 }, { 166, 623 }, { 167, 623 }, { 168, 623 }, { 169, 623 },
 { 170, 623 }, { 171, 623 }, { 172, 623 }, { 173, 623 }, { 174, 623 },
 { 175, 623 }, { 176, 623 }, { 177, 623 }, { 178, 623 }, { 179, 623 },
 { 180, 623 }, { 181, 623 }, { 182, 623 }, { 183, 623 }, { 184, 623 },
 { 185, 623 }, { 186, 623 }, { 187, 623 }, { 188, 623 }, { 189, 623 },
 { 190, 623 }, { 191, 623 }, { 192, 623 }, { 193, 623 }, { 194, 623 },
 { 195, 623 }, { 196, 623 }, { 197, 623 }, { 198, 623 }, { 199, 623 },
 { 200, 623 }, { 201, 623 }, { 202, 623 }, { 203, 623 }, { 204, 623 },
 { 205, 623 }, { 206, 623 }, { 207, 623 }, { 208, 623 }, { 209, 623 },
 { 210, 623 }, { 211, 623 }, { 212, 623 }, { 213, 623 }, { 214, 623 },

 { 215, 623 }, { 216, 623 }, { 217, 623 }, { 218, 623 }, { 219, 623 },
 { 220, 623 }, { 221, 623 }, { 222, 623 }, { 223, 623 }, { 224, 623 },
 { 225, 623 }, { 226, 623 }, { 227, 623 }, { 228, 623 }, { 229, 623 },
 { 230, 623 }, { 231, 623 }, { 232, 623 }, { 233, 623 }, { 234, 623 },
 { 235, 623 }, { 236, 623 }, { 237, 623 }, { 238, 623 }, { 239, 623 },
 { 240, 623 }, { 241, 623 }, { 242, 623 }, { 243, 623 }, { 244, 623 },
 { 245, 623 }, { 246, 623 }, { 247, 623 }, { 248, 623 }, { 249, 623 },
 { 250, 623 }, { 251, 623 }, { 252, 623 }, { 253, 623 }, { 254, 623 },
 { 255, 623 }, { 256, 623 }, {   0,  20 }, {   0,5484 }, {   0,   7 },
 {   0,5482 }, {   1, 879 }, {   2, 879 }, {   3, 879 }, {   4, 879 },

 {   5, 879 }, {   6, 879 }, {   7, 879 }, {   8, 879 }, {   9, 879 },
 {   0,   0 }, {  11, 879 }, {  12, 879 }, {  13, 879 }, {  14, 879 },
 {  15, 879 }, {  16, 879 }, {  17, 879 }, {  18, 879 }, {  19, 879 },
 {  20, 879 }, {  21, 879 }, {  22, 879 }, {  23, 879 }, {  24, 879 },
 {  25, 879 }, {  26, 879 }, {  27, 879 }, {  28, 879 }, {  29, 879 },
 {  30, 879 }, {  31, 879 }, {  32, 879 }, {  33, 879 }, {  34, 879 },
 {  35, 879 }, {  36, 879 }, {  37, 879 }, {  38, 879 }, {  39, 879 },
 {  40, 879 }, {  41, 879 }, {  42, 879 }, {  43, 879 }, {  44, 879 },
 {  45, 879 }, {  46, 879 }, {  47, 879 }, {  48, 879 }, {  49, 879 },
 {  50, 879 }, {  51, 879 }, {  52, 879 }, {  53, 879 }, {  54, 879 },

 {  55, 879 }, {  56, 879 }, {  57, 879 }, {  58, 879 }, {  59, 879 },
 {  60, 879 }, {  61, 879 }, {  62, 879 }, {  63, 879 }, {  64, 879 },
 {  65, 879 }, {  66, 879 }, {  67, 879 }, {  68, 879 }, {  69, 879 },
 {  70, 879 }, {  71, 879 }, {  72, 879 }, {  73, 879 }, {  74, 879 },
 {  75, 879 }, {  76, 879 }, {  77, 879 }, {  78, 879 }, {  79, 879 },
 {  80, 879 }, {  81, 879 }, {  82, 879 }, {  83, 879 }, {  84, 879 },
 {  85, 879 }, {  86, 879 }, {  87, 879 }, {  88, 879 }, {  89, 879 },
 {  90, 879 }, {  91, 879 }, {  92, 879 }, {  93, 879 }, {  94, 879 },
 {  95, 879 }, {  96, 879 }, {  97, 879 }, {  98, 879 }, {  99, 879 },
 { 100, 879 }, { 101, 879 }, { 102, 879 }, { 103, 879 }, { 104, 879 },

 { 105, 879 }, { 106, 879 }, { 107, 879 }, { 108, 879 }, { 109, 879 },
 { 110, 879 }, { 111, 879 }, { 112, 879 }, { 113, 879 }, { 114, 879 },
 { 115, 879 }, { 116, 879 }, { 117, 879 }, { 118, 879 }, { 119, 879 },
 { 120, 879 }, { 121, 879 }, { 122, 879 }, { 123, 879 }, { 124, 879 },
 { 125, 879 }, { 126, 879 }, { 127, 879 }, { 128, 879 }, { 129, 879 },
 { 130, 879 }, { 131, 879 }, { 132, 879 }, { 133, 879 }, { 134, 879 },
 { 135, 879 }, { 136, 879 }, { 137, 879 }, { 138, 879 }, { 139, 879 },
 { 140, 879 }, { 141, 879 }, { 142, 879 }, { 143, 879 }, { 144, 879 },
 { 145, 879 }, { 146, 879 }, { 147, 879 }, { 148, 879 }, { 149, 879 },
 { 150, 879 }, { 151, 879 }, { 152, 879 }, { 153, 879 }, { 154, 879 },

 { 155, 879 }, { 156, 879 }, { 157, 879 }, { 158, 879 }, { 159, 879 },
 { 160, 879 }, { 161, 879 }, { 162, 879 }, { 163, 879 }, { 164, 879 },
 { 165, 879 }, { 166, 879 }, { 167, 879 }, { 168, 879 }, { 169, 879 },
 { 170, 879 }, { 171, 879 }, { 172, 879 }, { 173, 879 }, { 174, 879 },
 { 175, 879 }, { 176, 879 }, { 177, 879 }, { 178, 879 }, { 179, 879 },
 { 180, 879 }, { 181, 879 }, { 182, 879 }, { 183, 879 }, { 184, 879 },
 { 185, 879 }, { 186, 879 }, { 187, 879 }, { 188, 879 }, { 189, 879 },
 { 190, 879 }, { 191, 879 }, { 192, 879 }, { 193, 879 }, { 194, 879 },
 { 195, 879 }, { 196, 879 }, { 197, 879 }, { 198, 879 }, { 199, 879 },
 { 200, 879 }, { 201, 879 }, { 202, 879 }, { 203, 879 }, { 204, 879 },

 { 205, 879 }, { 206, 879 }, { 207, 879 }, { 208, 879 }, { 209, 879 },
 { 210, 879 }, { 211, 879 }, { 212, 879 }, { 213, 879 }, { 214, 879 },
 { 215, 879 }, { 216, 879 }, { 217, 879 }, { 218, 879 }, { 219, 879 },
 { 220, 879 }, { 221, 879 }, { 222, 879 }, { 223, 879 }, { 224, 879 },
 { 225, 879 }, { 226, 879 }, { 227, 879 }, { 228, 879 }, { 229, 879 },
 { 230, 879 }, { 231, 879 }, { 232, 879 }, { 233, 879 }, { 234, 879 },
 { 235, 879 }, { 236, 879 }, { 237, 879 }, { 238, 879 }, { 239, 879 },
 { 240, 879 }, { 241, 879 }, { 242, 879 }, { 243, 879 }, { 244, 879 },
 { 245, 879 }, { 246, 879 }, { 247, 879 }, { 248, 879 }, { 249, 879 },
 { 250, 879 }, { 251, 879 }, { 252, 879 }, { 253, 879 }, { 254, 879 },

 { 255, 879 }, { 256, 879 }, {   0,  51 }, {   0,5224 }, {   0,  50 },
 {   0,5222 }, {   0,  51 }, {   0,5220 }, {   0,  11 }, {   0,5218 },
 {   0,  12 }, {   0,5216 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {  10, 875 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },

 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {  67, 875 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },

 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {  99, 875 }, {   0,   8 }, {   0,5119 }, {   1,   0 },
 {   2,   0 }, {   3,   0 }, {   4,   0 }, {   5,   0 }, {   6,   0 },
 {   7,   0 }, {   8,   0 }, {   9,   0 }, {  10, 776 }, {  11,   0 },
 {  12,   0 }, {  13,   0 }, {  14,   0 }, {  15,   0 }, {  16,   0 },
 {  17,   0 }, {  18,   0 }, {  19,   0 }, {  20,   0 }, {  21,   0 },
 {  22,   0 }, {  23,   0 }, {  24,   0 }, {  25,   0 }, {  26,   0 },
 {  27,   0 }, {  28,   0 }, {  29,   0 }, {  30,   0 }, {  31,   0 },
 {  32, -97 }, {  33,   0 }, {  34,   0 }, {  35,   0 }, {  36,   0 },
 {  37,   0 }, {  38,   0 }, {  39,   0 }, {  40,   0 }, {  41,   0 },

 {  42,   0 }, {  43,   0 }, {  44,   0 }, {  45,   0 }, {  46,   0 },
 {  47,   0 }, {  48,   0 }, {  49,   0 }, {  50,   0 }, {  51,   0 },
 {  52,   0 }, {  53,   0 }, {  54,   0 }, {  55,   0 }, {  56,   0 },
 {  57,   0 }, {  58, 258 }, {  59,   0 }, {  60,   0 }, {  61,   0 },
 {  62,   0 }, {  63,   0 }, {  64,   0 }, {  65,   0 }, {  66,   0 },
 {  67,   0 }, {  68,   0 }, {  69,   0 }, {  70,   0 }, {  71,   0 },
 {  72,   0 }, {  73,   0 }, {  74,   0 }, {  75,   0 }, {  76,   0 },
 {  77,   0 }, {  78,   0 }, {  79,   0 }, {  80,   0 }, {  81,   0 },
 {  82,   0 }, {  83,   0 }, {  84,   0 }, {  85,   0 }, {  86,   0 },
 {  87,   0 }, {  88,   0 }, {  89,   0 }, {  90,   0 }, {  91,   0 },

 {  92,   0 }, {  93,   0 }, {  94,   0 }, {  95,   0 }, {  96,   0 },
 {  97,   0 }, {  98,   0 }, {  99,   0 }, { 100,   0 }, { 101,   0 },
 { 102,   0 }, { 103,   0 }, { 104,   0 }, { 105,   0 }, { 106,   0 },
 { 107,   0 }, { 108,   0 }, { 109,   0 }, { 110,   0 }, { 111,   0 },
 { 112,   0 }, { 113,   0 }, { 114,   0 }, { 115,   0 }, { 116,   0 },
 { 117,   0 }, { 118,   0 }, { 119,   0 }, { 120,   0 }, { 121,   0 },
 { 122,   0 }, { 123,   0 }, { 124,   0 }, { 125,   0 }, { 126,   0 },
 { 127,   0 }, { 128,   0 }, { 129,   0 }, { 130,   0 }, { 131,   0 },
 { 132,   0 }, { 133,   0 }, { 134,   0 }, { 135,   0 }, { 136,   0 },
 { 137,   0 }, { 138,   0 }, { 139,   0 }, { 140,   0 }, { 141,   0 },

 { 142,   0 }, { 143,   0 }, { 144,   0 }, { 145,   0 }, { 146,   0 },
 { 147,   0 }, { 148,   0 }, { 149,   0 }, { 150,   0 }, { 151,   0 },
 { 152,   0 }, { 153,   0 }, { 154,   0 }, { 155,   0 }, { 156,   0 },
 { 157,   0 }, { 158,   0 }, { 159,   0 }, { 160,   0 }, { 161,   0 },
 { 162,   0 }, { 163,   0 }, { 164,   0 }, { 165,   0 }, { 166,   0 },
 { 167,   0 }, { 168,   0 }, { 169,   0 }, { 170,   0 }, { 171,   0 },
 { 172,   0 }, { 173,   0 }, { 174,   0 }, { 175,   0 }, { 176,   0 },
 { 177,   0 }, { 178,   0 }, { 179,   0 }, { 180,   0 }, { 181,   0 },
 { 182,   0 }, { 183,   0 }, { 184,   0 }, { 185,   0 }, { 186,   0 },
 { 187,   0 }, { 188,   0 }, { 189,   0 }, { 190,   0 }, { 191,   0 },

 { 192,   0 }, { 193,   0 }, { 194,   0 }, { 195,   0 }, { 196,   0 },
 { 197,   0 }, { 198,   0 }, { 199,   0 }, { 200,   0 }, { 201,   0 },
 { 202,   0 }, { 203,   0 }, { 204,   0 }, { 205,   0 }, { 206,   0 },
 { 207,   0 }, { 208,   0 }, { 209,   0 }, { 210,   0 }, { 211,   0 },
 { 212,   0 }, { 213,   0 }, { 214,   0 }, { 215,   0 }, { 216,   0 },
 { 217,   0 }, { 218,   0 }, { 219,   0 }, { 220,   0 }, { 221,   0 },
 { 222,   0 }, { 223,   0 }, { 224,   0 }, { 225,   0 }, { 226,   0 },
 { 227,   0 }, { 228,   0 }, { 229,   0 }, { 230,   0 }, { 231,   0 },
 { 232,   0 }, { 233,   0 }, { 234,   0 }, { 235,   0 }, { 236,   0 },
 { 237,   0 }, { 238,   0 }, { 239,   0 }, { 240,   0 }, { 241,   0 },

 { 242,   0 }, { 243,   0 }, { 244,   0 }, { 245,   0 }, { 246,   0 },
 { 247,   0 }, { 248,   0 }, { 249,   0 }, { 250,   0 }, { 251,   0 },
 { 252,   0 }, { 253,   0 }, { 254,   0 }, { 255,   0 }, { 256,   0 },
 {   0,  10 }, {   0,4861 }, {   1, 634 }, {   2, 634 }, {   3, 634 },
 {   4, 634 }, {   5, 634 }, {   6, 634 }, {   7, 634 }, {   8, 634 },
 {   9, 634 }, {  10, 522 }, {  11, 634 }, {  12, 634 }, {  13, 634 },
 {  14, 634 }, {  15, 634 }, {  16, 634 }, {  17, 634 }, {  18, 634 },
 {  19, 634 }, {  20, 634 }, {  21, 634 }, {  22, 634 }, {  23, 634 },
 {  24, 634 }, {  25, 634 }, {  26, 634 }, {  27, 634 }, {  28, 634 },
 {  29, 634 }, {  30, 634 }, {  31, 634 }, {  32, 892 }, {  33, 634 },

 {  34, 634 }, {  35, 634 }, {  36, 634 }, {  37, 634 }, {  38, 634 },
 {  39, 634 }, {  40, 634 }, {  41, 634 }, {  42, 634 }, {  43, 634 },
 {  44, 634 }, {  45, 634 }, {  46, 634 }, {  47, 634 }, {  48, 634 },
 {  49, 634 }, {  50, 634 }, {  51, 634 }, {  52, 634 }, {  53, 634 },
 {  54, 634 }, {  55, 634 }, {  56, 634 }, {  57, 634 }, {  58, 524 },
 {  59, 634 }, {  60, 634 }, {  61, 634 }, {  62, 634 }, {  63, 634 },
 {  64, 634 }, {  65, 634 }, {  66, 634 }, {  67, 634 }, {  68, 634 },
 {  69, 634 }, {  70, 634 }, {  71, 634 }, {  72, 634 }, {  73, 634 },
 {  74, 634 }, {  75, 634 }, {  76, 634 }, {  77, 634 }, {  78, 634 },
 {  79, 634 }, {  80, 634 }, {  81, 634 }, {  82, 634 }, {  83, 634 },

 {  84, 634 }, {  85, 634 }, {  86, 634 }, {  87, 634 }, {  88, 634 },
 {  89, 634 }, {  90, 634 }, {  91, 634 }, {  92, 634 }, {  93, 634 },
 {  94, 634 }, {  95, 634 }, {  96, 634 }, {  97, 634 }, {  98, 634 },
 {  99, 634 }, { 100, 634 }, { 101, 634 }, { 102, 634 }, { 103, 634 },
 { 104, 634 }, { 105, 634 }, { 106, 634 }, { 107, 634 }, { 108, 634 },
 { 109, 634 }, { 110, 634 }, { 111, 634 }, { 112, 634 }, { 113, 634 },
 { 114, 634 }, { 115, 634 }, { 116, 634 }, { 117, 634 }, { 118, 634 },
 { 119, 634 }, { 120, 634 }, { 121, 634 }, { 122, 634 }, { 123, 634 },
 { 124, 634 }, { 125, 634 }, { 126, 634 }, { 127, 634 }, { 128, 634 },
 { 129, 634 }, { 130, 634 }, { 131, 634 }, { 132, 634 }, { 133, 634 },

 { 134, 634 }, { 135, 634 }, { 136, 634 }, { 137, 634 }, { 138, 634 },
 { 139, 634 }, { 140, 634 }, { 141, 634 }, { 142, 634 }, { 143, 634 },
 { 144, 634 }, { 145, 634 }, { 146, 634 }, { 147, 634 }, { 148, 634 },
 { 149, 634 }, { 150, 634 }, { 151, 634 }, { 152, 634 }, { 153, 634 },
 { 154, 634 }, { 155, 634 }, { 156, 634 }, { 157, 634 }, { 158, 634 },
 { 159, 634 }, { 160, 634 }, { 161, 634 }, { 162, 634 }, { 163, 634 },
 { 164, 634 }, { 165, 634 }, { 166, 634 }, { 167, 634 }, { 168, 634 },
 { 169, 634 }, { 170, 634 }, { 171, 634 }, { 172, 634 }, { 173, 634 },
 { 174, 634 }, { 175, 634 }, { 176, 634 }, { 177, 634 }, { 178, 634 },
 { 179, 634 }, { 180, 634 }, { 181, 634 }, { 182, 634 }, { 183, 634 },

 { 184, 634 }, { 185, 634 }, { 186, 634 }, { 187, 634 }, { 188, 634 },
 { 189, 634 }, { 190, 634 }, { 191, 634 }, { 192, 634 }, { 193, 634 },
 { 194, 634 }, { 195, 634 }, { 196, 634 }, { 197, 634 }, { 198, 634 },
 { 199, 634 }, { 200, 634 }, { 201, 634 }, { 202, 634 }, { 203, 634 },
 { 204, 634 }, { 205, 634 }, { 206, 634 }, { 207, 634 }, { 208, 634 },
 { 209, 634 }, { 210, 634 }, { 211, 634 }, { 212, 634 }, { 213, 634 },
 { 214, 634 }, { 215, 634 }, { 216, 634 }, { 217, 634 }, { 218, 634 },
 { 219, 634 }, { 220, 634 }, { 221, 634 }, { 222, 634 }, { 223, 634 },
 { 224, 634 }, { 225, 634 }, { 226, 634 }, { 227, 634 }, { 228, 634 },
 { 229, 634 }, { 230, 634 }, { 231, 634 }, { 232, 634 }, { 233, 634 },

 { 234, 634 }, { 235, 634 }, { 236, 634 }, { 237, 634 }, { 238, 634 },
 { 239, 634 }, { 240, 634 }, { 241, 634 }, { 242, 634 }, { 243, 634 },
 { 244, 634 }, { 245, 634 }, { 246, 634 }, { 247, 634 }, { 248, 634 },
 { 249, 634 }, { 250, 634 }, { 251, 634 }, { 252, 634 }, { 253, 634 },
 { 254, 634 }, { 255, 634 }, { 256, 634 }, {   0,   7 }, {   0,4603 },
 {   1,   0 }, {   2,   0 }, {   3,   0 }, {   4,   0 }, {   5,   0 },
 {   6,   0 }, {   7,   0 }, {   8,   0 }, {   9,   0 }, {   0,   0 },
 {  11,   0 }, {  12,   0 }, {  13,   0 }, {  14,   0 }, {  15,   0 },
 {  16,   0 }, {  17,   0 }, {  18,   0 }, {  19,   0 }, {  20,   0 },
 {  21,   0 }, {  22,   0 }, {  23,   0 }, {  24,   0 }, {  25,   0 },

 {  26,   0 }, {  27,   0 }, {  28,   0 }, {  29,   0 }, {  30,   0 },
 {  31,   0 }, {  32,   0 }, {  33,   0 }, {  34,   0 }, {  35,   0 },
 {  36,   0 }, {  37,   0 }, {  38,   0 }, {  39,   0 }, {  40,   0 },
 {  41,   0 }, {  42,   0 }, {  43,   0 }, {  44,   0 }, {  45,   0 },
 {  46,   0 }, {  47,   0 }, {  48,   0 }, {  49,   0 }, {  50,   0 },
 {  51,   0 }, {  52,   0 }, {  53,   0 }, {  54,   0 }, {  55,   0 },
 {  56,   0 }, {  57,   0 }, {  58,   0 }, {  59,   0 }, {  60,   0 },
 {  61,   0 }, {  62,   0 }, {  63,   0 }, {  64,   0 }, {  65,   0 },
 {  66,   0 }, {  67,   0 }, {  68,   0 }, {  69,   0 }, {  70,   0 },
 {  71,   0 }, {  72,   0 }, {  73,   0 }, {  74,   0 }, {  75,   0 },

 {  76,   0 }, {  77,   0 }, {  78,   0 }, {  79,   0 }, {  80,   0 },
 {  81,   0 }, {  82,   0 }, {  83,   0 }, {  84,   0 }, {  85,   0 },
 {  86,   0 }, {  87,   0 }, {  88,   0 }, {  89,   0 }, {  90,   0 },
 {  91,   0 }, {  92,   0 }, {  93,   0 }, {  94,   0 }, {  95,   0 },
 {  96,   0 }, {  97,   0 }, {  98,   0 }, {  99,   0 }, { 100,   0 },
 { 101,   0 }, { 102,   0 }, { 103,   0 }, { 104,   0 }, { 105,   0 },
 { 106,   0 }, { 107,   0 }, { 108,   0 }, { 109,   0 }, { 110,   0 },
 { 111,   0 }, { 112,   0 }, { 113,   0 }, { 114,   0 }, { 115,   0 },
 { 116,   0 }, { 117,   0 }, { 118,   0 }, { 119,   0 }, { 120,   0 },
 { 121,   0 }, { 122,   0 }, { 123,   0 }, { 124,   0 }, { 125,   0 },

 { 126,   0 }, { 127,   0 }, { 128,   0 }, { 129,   0 }, { 130,   0 },
 { 131,   0 }, { 132,   0 }, { 133,   0 }, { 134,   0 }, { 135,   0 },
 { 136,   0 }, { 137,   0 }, { 138,   0 }, { 139,   0 }, { 140,   0 },
 { 141,   0 }, { 142,   0 }, { 143,   0 }, { 144,   0 }, { 145,   0 },
 { 146,   0 }, { 147,   0 }, { 148,   0 }, { 149,   0 }, { 150,   0 },
 { 151,   0 }, { 152,   0 }, { 153,   0 }, { 154,   0 }, { 155,   0 },
 { 156,   0 }, { 157,   0 }, { 158,   0 }, { 159,   0 }, { 160,   0 },
 { 161,   0 }, { 162,   0 }, { 163,   0 }, { 164,   0 }, { 165,   0 },
 { 166,   0 }, { 167,   0 }, { 168,   0 }, { 169,   0 }, { 170,   0 },
 { 171,   0 }, { 172,   0 }, { 173,   0 }, { 174,   0 }, { 175,   0 },

 { 176,   0 }, { 177,   0 }, { 178,   0 }, { 179,   0 }, { 180,   0 },
 { 181,   0 }, { 182,   0 }, { 183,   0 }, { 184,   0 }, { 185,   0 },
 { 186,   0 }, { 187,   0 }, { 188,   0 }, { 189,   0 }, { 190,   0 },
 { 191,   0 }, { 192,   0 }, { 193,   0 }, { 194,   0 }, { 195,   0 },
 { 196,   0 }, { 197,   0 }, { 198,   0 }, { 199,   0 }, { 200,   0 },
 { 201,   0 }, { 202,   0 }, { 203,   0 }, { 204,   0 }, { 205,   0 },
 { 206,   0 }, { 207,   0 }, { 208,   0 }, { 209,   0 }, { 210,   0 },
 { 211,   0 }, { 212,   0 }, { 213,   0 }, { 214,   0 }, { 215,   0 },
 { 216,   0 }, { 217,   0 }, { 218,   0 }, { 219,   0 }, { 220,   0 },
 { 221,   0 }, { 222,   0 }, { 223,   0 }, { 224,   0 }, { 225,   0 },

 { 226,   0 }, { 227,   0 }, { 228,   0 }, { 229,   0 }, { 230,   0 },
 { 231,   0 }, { 232,   0 }, { 233,   0 }, { 234,   0 }, { 235,   0 },
 { 236,   0 }, { 237,   0 }, { 238,   0 }, { 239,   0 }, { 240,   0 },
 { 241,   0 }, { 242,   0 }, { 243,   0 }, { 244,   0 }, { 245,   0 },
 { 246,   0 }, { 247,   0 }, { 248,   0 }, { 249,   0 }, { 250,   0 },
 { 251,   0 }, { 252,   0 }, { 253,   0 }, { 254,   0 }, { 255,   0 },
 { 256,   0 }, {   0,  49 }, {   0,4345 }, {   0,  11 }, {   0,4343 },
 {   0,  13 }, {   0,4341 }, {   0,   9 }, {   0,4339 }, {   0,  14 },
 {   0,4337 }, {   0,  48 }, {   0,4335 }, {   0,   6 }, {   0,4333 },
 {   0,   2 }, {   0,4331 }, {   0,  15 }, {   0,4329 }, {   0,   0 },

 {  10,   8 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {  32,1142 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },

 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {  73,1398 }, {  84,  10 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, { 105,1398 }, { 116,  10 }, {   0,   5 },

 {   0,4227 }, {   1, 516 }, {   2, 516 }, {   3, 516 }, {   4, 516 },
 {   5, 516 }, {   6, 516 }, {   7, 516 }, {   8, 516 }, {   9, 516 },
 {  10,-106 }, {  11, 516 }, {  12, 516 }, {  13, 516 }, {  14, 516 },
 {  15, 516 }, {  16, 516 }, {  17, 516 }, {  18, 516 }, {  19, 516 },
 {  20, 516 }, {  21, 516 }, {  22, 516 }, {  23, 516 }, {  24, 516 },
 {  25, 516 }, {  26, 516 }, {  27, 516 }, {  28, 516 }, {  29, 516 },
 {  30, 516 }, {  31, 516 }, {  32, 516 }, {  33, 516 }, {  34, 516 },
 {  35, 516 }, {  36, 516 }, {  37, 516 }, {  38, 516 }, {  39, 516 },
 {  40, 516 }, {  41, 516 }, {  42, 516 }, {  43, 516 }, {  44, 516 },
 {  45, 516 }, {  46, 516 }, {  47, 516 }, {  48, 516 }, {  49, 516 },

 {  50, 516 }, {  51, 516 }, {  52, 516 }, {  53, 516 }, {  54, 516 },
 {  55, 516 }, {  56, 516 }, {  57, 516 }, {  58, 516 }, {  59, 516 },
 {  60, 516 }, {  61, 516 }, {  62, 516 }, {  63, 516 }, {  64, 516 },
 {  65, 516 }, {  66, 516 }, {  67, 516 }, {  68, 516 }, {  69, 516 },
 {  70, 516 }, {  71, 516 }, {  72, 516 }, {  73, 516 }, {  74, 516 },
 {  75, 516 }, {  76, 516 }, {  77, 516 }, {  78, 516 }, {  79, 516 },
 {  80, 516 }, {  81, 516 }, {  82, 516 }, {  83, 516 }, {  84, 516 },
 {  85, 516 }, {  86, 516 }, {  87, 516 }, {  88, 516 }, {  89, 516 },
 {  90, 516 }, {  91, 516 }, {  92, 516 }, {  93, 516 }, {  94, 516 },
 {  95, 516 }, {  96, 516 }, {  97, 516 }, {  98, 516 }, {  99, 516 },

 { 100, 516 }, { 101, 516 }, { 102, 516 }, { 103, 516 }, { 104, 516 },
 { 105, 516 }, { 106, 516 }, { 107, 516 }, { 108, 516 }, { 109, 516 },
 { 110, 516 }, { 111, 516 }, { 112, 516 }, { 113, 516 }, { 114, 516 },
 { 115, 516 }, { 116, 516 }, { 117, 516 }, { 118, 516 }, { 119, 516 },
 { 120, 516 }, { 121, 516 }, { 122, 516 }, { 123, 516 }, { 124, 516 },
 { 125, 516 }, { 126, 516 }, { 127, 516 }, { 128, 516 }, { 129, 516 },
 { 130, 516 }, { 131, 516 }, { 132, 516 }, { 133, 516 }, { 134, 516 },
 { 135, 516 }, { 136, 516 }, { 137, 516 }, { 138, 516 }, { 139, 516 },
 { 140, 516 }, { 141, 516 }, { 142, 516 }, { 143, 516 }, { 144, 516 },
 { 145, 516 }, { 146, 516 }, { 147, 516 }, { 148, 516 }, { 149, 516 },

 { 150, 516 }, { 151, 516 }, { 152, 516 }, { 153, 516 }, { 154, 516 },
 { 155, 516 }, { 156, 516 }, { 157, 516 }, { 158, 516 }, { 159, 516 },
 { 160, 516 }, { 161, 516 }, { 162, 516 }, { 163, 516 }, { 164, 516 },
 { 165, 516 }, { 166, 516 }, { 167, 516 }, { 168, 516 }, { 169, 516 },
 { 170, 516 }, { 171, 516 }, { 172, 516 }, { 173, 516 }, { 174, 516 },
 { 175, 516 }, { 176, 516 }, { 177, 516 }, { 178, 516 }, { 179, 516 },
 { 180, 516 }, { 181, 516 }, { 182, 516 }, { 183, 516 }, { 184, 516 },
 { 185, 516 }, { 186, 516 }, { 187, 516 }, { 188, 516 }, { 189, 516 },
 { 190, 516 }, { 191, 516 }, { 192, 516 }, { 193, 516 }, { 194, 516 },
 { 195, 516 }, { 196, 516 }, { 197, 516 }, { 198, 516 }, { 199, 516 },

 { 200, 516 }, { 201, 516 }, { 202, 516 }, { 203, 516 }, { 204, 516 },
 { 205, 516 }, { 206, 516 }, { 207, 516 }, { 208, 516 }, { 209, 516 },
 { 210, 516 }, { 211, 516 }, { 212, 516 }, { 213, 516 }, { 214, 516 },
 { 215, 516 }, { 216, 516 }, { 217, 516 }, { 218, 516 }, { 219, 516 },
 { 220, 516 }, { 221, 516 }, { 222, 516 }, { 223, 516 }, { 224, 516 },
 { 225, 516 }, { 226, 516 }, { 227, 516 }, { 228, 516 }, { 229, 516 },
 { 230, 516 }, { 231, 516 }, { 232, 516 }, { 233, 516 }, { 234, 516 },
 { 235, 516 }, { 236, 516 }, { 237, 516 }, { 238, 516 }, { 239, 516 },
 { 240, 516 }, { 241, 516 }, { 242, 516 }, { 243, 516 }, { 244, 516 },
 { 245, 516 }, { 246, 516 }, { 247, 516 }, { 248, 516 }, { 249, 516 },

 { 250, 516 }, { 251, 516 }, { 252, 516 }, { 253, 516 }, { 254, 516 },
 { 255, 516 }, { 256, 516 }, {   0,   1 }, {   0,3969 }, {   1, 516 },
 {   2, 516 }, {   3, 516 }, {   4, 516 }, {   5, 516 }, {   6, 516 },
 {   7, 516 }, {   8, 516 }, {   9, 516 }, {  10,-362 }, {  11, 516 },
 {  12, 516 }, {  13, 516 }, {  14, 516 }, {  15, 516 }, {  16, 516 },
 {  17, 516 }, {  18, 516 }, {  19, 516 }, {  20, 516 }, {  21, 516 },
 {  22, 516 }, {  23, 516 }, {  24, 516 }, {  25, 516 }, {  26, 516 },
 {  27, 516 }, {  28, 516 }, {  29, 516 }, {  30, 516 }, {  31, 516 },
 {  32, 516 }, {  33, 516 }, {  34, 516 }, {  35, 516 }, {  36, 516 },
 {  37, 516 }, {  38, 516 }, {  39, 516 }, {  40, 516 }, {  41, 516 },

 {  42, 516 }, {  43, 516 }, {  44, 516 }, {  45, 516 }, {  46, 516 },
 {  47, 516 }, {  48, 516 }, {  49, 516 }, {  50, 516 }, {  51, 516 },
 {  52, 516 }, {  53, 516 }, {  54, 516 }, {  55, 516 }, {  56, 516 },
 {  57, 516 }, {  58, 516 }, {  59, 516 }, {  60, 516 }, {  61, 516 },
 {  62, 516 }, {  63, 516 }, {  64, 516 }, {  65, 516 }, {  66, 516 },
 {  67, 516 }, {  68, 516 }, {  69, 516 }, {  70, 516 }, {  71, 516 },
 {  72, 516 }, {  73, 516 }, {  74, 516 }, {  75, 516 }, {  76, 516 },
 {  77, 516 }, {  78, 516 }, {  79, 516 }, {  80, 516 }, {  81, 516 },
 {  82, 516 }, {  83, 516 }, {  84, 516 }, {  85, 516 }, {  86, 516 },
 {  87, 516 }, {  88, 516 }, {  89, 516 }, {  90, 516 }, {  91, 516 },

 {  92, 516 }, {  93, 516 }, {  94, 516 }, {  95, 516 }, {  96, 516 },
 {  97, 516 }, {  98, 516 }, {  99, 516 }, { 100, 516 }, { 101, 516 },
 { 102, 516 }, { 103, 516 }, { 104, 516 }, { 105, 516 }, { 106, 516 },
 { 107, 516 }, { 108, 516 }, { 109, 516 }, { 110, 516 }, { 111, 516 },
 { 112, 516 }, { 113, 516 }, { 114, 516 }, { 115, 516 }, { 116, 516 },
 { 117, 516 }, { 118, 516 }, { 119, 516 }, { 120, 516 }, { 121, 516 },
 { 122, 516 }, { 123, 516 }, { 124, 516 }, { 125, 516 }, { 126, 516 },
 { 127, 516 }, { 128, 516 }, { 129, 516 }, { 130, 516 }, { 131, 516 },
 { 132, 516 }, { 133, 516 }, { 134, 516 }, { 135, 516 }, { 136, 516 },
 { 137, 516 }, { 138, 516 }, { 139, 516 }, { 140, 516 }, { 141, 516 },

 { 142, 516 }, { 143, 516 }, { 144, 516 }, { 145, 516 }, { 146, 516 },
 { 147, 516 }, { 148, 516 }, { 149, 516 }, { 150, 516 }, { 151, 516 },
 { 152, 516 }, { 153, 516 }, { 154, 516 }, { 155, 516 }, { 156, 516 },
 { 157, 516 }, { 158, 516 }, { 159, 516 }, { 160, 516 }, { 161, 516 },
 { 162, 516 }, { 163, 516 }, { 164, 516 }, { 165, 516 }, { 166, 516 },
 { 167, 516 }, { 168, 516 }, { 169, 516 }, { 170, 516 }, { 171, 516 },
 { 172, 516 }, { 173, 516 }, { 174, 516 }, { 175, 516 }, { 176, 516 },
 { 177, 516 }, { 178, 516 }, { 179, 516 }, { 180, 516 }, { 181, 516 },
 { 182, 516 }, { 183, 516 }, { 184, 516 }, { 185, 516 }, { 186, 516 },
 { 187, 516 }, { 188, 516 }, { 189, 516 }, { 190, 516 }, { 191, 516 },

 { 192, 516 }, { 193, 516 }, { 194, 516 }, { 195, 516 }, { 196, 516 },
 { 197, 516 }, { 198, 516 }, { 199, 516 }, { 200, 516 }, { 201, 516 },
 { 202, 516 }, { 203, 516 }, { 204, 516 }, { 205, 516 }, { 206, 516 },
 { 207, 516 }, { 208, 516 }, { 209, 516 }, { 210, 516 }, { 211, 516 },
 { 212, 516 }, { 213, 516 }, { 214, 516 }, { 215, 516 }, { 216, 516 },
 { 217, 516 }, { 218, 516 }, { 219, 516 }, { 220, 516 }, { 221, 516 },
 { 222, 516 }, { 223, 516 }, { 224, 516 }, { 225, 516 }, { 226, 516 },
 { 227, 516 }, { 228, 516 }, { 229, 516 }, { 230, 516 }, { 231, 516 },
 { 232, 516 }, { 233, 516 }, { 234, 516 }, { 235, 516 }, { 236, 516 },
 { 237, 516 }, { 238, 516 }, { 239, 516 }, { 240, 516 }, { 241, 516 },

 { 242, 516 }, { 243, 516 }, { 244, 516 }, { 245, 516 }, { 246, 516 },
 { 247, 516 }, { 248, 516 }, { 249, 516 }, { 250, 516 }, { 251, 516 },
 { 252, 516 }, { 253, 516 }, { 254, 516 }, { 255, 516 }, { 256, 516 },
 {   0,   5 }, {   0,3711 }, {   1,   0 }, {   2,   0 }, {   3,   0 },
 {   4,   0 }, {   5,   0 }, {   6,   0 }, {   7,   0 }, {   8,   0 },
 {   9,   0 }, {  10,-622 }, {  11,   0 }, {  12,   0 }, {  13,   0 },
 {  14,   0 }, {  15,   0 }, {  16,   0 }, {  17,   0 }, {  18,   0 },
 {  19,   0 }, {  20,   0 }, {  21,   0 }, {  22,   0 }, {  23,   0 },
 {  24,   0 }, {  25,   0 }, {  26,   0 }, {  27,   0 }, {  28,   0 },
 {  29,   0 }, {  30,   0 }, {  31,   0 }, {  32,   0 }, {  33,   0 },

 {  34,   0 }, {  35,   0 }, {  36,   0 }, {  37,   0 }, {  38,   0 },
 {  39,   0 }, {  40,   0 }, {  41,   0 }, {  42,   0 }, {  43,   0 },
 {  44,   0 }, {  45,   0 }, {  46,   0 }, {  47,   0 }, {  48,   0 },
 {  49,   0 }, {  50,   0 }, {  51,   0 }, {  52,   0 }, {  53,   0 },
 {  54,   0 }, {  55,   0 }, {  56,   0 }, {  57,   0 }, {  58,   0 },
 {  59,   0 }, {  60,   0 }, {  61,   0 }, {  62,   0 }, {  63,   0 },
 {  64,   0 }, {  65,   0 }, {  66,   0 }, {  67,   0 }, {  68,   0 },
 {  69,   0 }, {  70,   0 }, {  71,   0 }, {  72,   0 }, {  73,   0 },
 {  74,   0 }, {  75,   0 }, {  76,   0 }, {  77,   0 }, {  78,   0 },
 {  79,   0 }, {  80,   0 }, {  81,   0 }, {  82,   0 }, {  83,   0 },

 {  84,   0 }, {  85,   0 }, {  86,   0 }, {  87,   0 }, {  88,   0 },
 {  89,   0 }, {  90,   0 }, {  91,   0 }, {  92,   0 }, {  93,   0 },
 {  94,   0 }, {  95,   0 }, {  96,   0 }, {  97,   0 }, {  98,   0 },
 {  99,   0 }, { 100,   0 }, { 101,   0 }, { 102,   0 }, { 103,   0 },
 { 104,   0 }, { 105,   0 }, { 106,   0 }, { 107,   0 }, { 108,   0 },
 { 109,   0 }, { 110,   0 }, { 111,   0 }, { 112,   0 }, { 113,   0 },
 { 114,   0 }, { 115,   0 }, { 116,   0 }, { 117,   0 }, { 118,   0 },
 { 119,   0 }, { 120,   0 }, { 121,   0 }, { 122,   0 }, { 123,   0 },
 { 124,   0 }, { 125,   0 }, { 126,   0 }, { 127,   0 }, { 128,   0 },
 { 129,   0 }, { 130,   0 }, { 131,   0 }, { 132,   0 }, { 133,   0 },

 { 134,   0 }, { 135,   0 }, { 136,   0 }, { 137,   0 }, { 138,   0 },
 { 139,   0 }, { 140,   0 }, { 141,   0 }, { 142,   0 }, { 143,   0 },
 { 144,   0 }, { 145,   0 }, { 146,   0 }, { 147,   0 }, { 148,   0 },
 { 149,   0 }, { 150,   0 }, { 151,   0 }, { 152,   0 }, { 153,   0 },
 { 154,   0 }, { 155,   0 }, { 156,   0 }, { 157,   0 }, { 158,   0 },
 { 159,   0 }, { 160,   0 }, { 161,   0 }, { 162,   0 }, { 163,   0 },
 { 164,   0 }, { 165,   0 }, { 166,   0 }, { 167,   0 }, { 168,   0 },
 { 169,   0 }, { 170,   0 }, { 171,   0 }, { 172,   0 }, { 173,   0 },
 { 174,   0 }, { 175,   0 }, { 176,   0 }, { 177,   0 }, { 178,   0 },
 { 179,   0 }, { 180,   0 }, { 181,   0 }, { 182,   0 }, { 183,   0 },

 { 184,   0 }, { 185,   0 }, { 186,   0 }, { 187,   0 }, { 188,   0 },
 { 189,   0 }, { 190,   0 }, { 191,   0 }, { 192,   0 }, { 193,   0 },
 { 194,   0 }, { 195,   0 }, { 196,   0 }, { 197,   0 }, { 198,   0 },
 { 199,   0 }, { 200,   0 }, { 201,   0 }, { 202,   0 }, { 203,   0 },
 { 204,   0 }, { 205,   0 }, { 206,   0 }, { 207,   0 }, { 208,   0 },
 { 209,   0 }, { 210,   0 }, { 211,   0 }, { 212,   0 }, { 213,   0 },
 { 214,   0 }, { 215,   0 }, { 216,   0 }, { 217,   0 }, { 218,   0 },
 { 219,   0 }, { 220,   0 }, { 221,   0 }, { 222,   0 }, { 223,   0 },
 { 224,   0 }, { 225,   0 }, { 226,   0 }, { 227,   0 }, { 228,   0 },
 { 229,   0 }, { 230,   0 }, { 231,   0 }, { 232,   0 }, { 233,   0 },

 { 234,   0 }, { 235,   0 }, { 236,   0 }, { 237,   0 }, { 238,   0 },
 { 239,   0 }, { 240,   0 }, { 241,   0 }, { 242,   0 }, { 243,   0 },
 { 244,   0 }, { 245,   0 }, { 246,   0 }, { 247,   0 }, { 248,   0 },
 { 249,   0 }, { 250,   0 }, { 251,   0 }, { 252,   0 }, { 253,   0 },
 { 254,   0 }, { 255,   0 }, { 256,   0 }, {   0,   3 }, {   0,3453 },
 {   1,   0 }, {   2,   0 }, {   3,   0 }, {   4,   0 }, {   5,   0 },
 {   6,   0 }, {   7,   0 }, {   8,   0 }, {   9,   0 }, {  10, 518 },
 {  11,   0 }, {  12,   0 }, {  13,   0 }, {  14,   0 }, {  15,   0 },
 {  16,   0 }, {  17,   0 }, {  18,   0 }, {  19,   0 }, {  20,   0 },
 {  21,   0 }, {  22,   0 }, {  23,   0 }, {  24,   0 }, {  25,   0 },

 {  26,   0 }, {  27,   0 }, {  28,   0 }, {  29,   0 }, {  30,   0 },
 {  31,   0 }, {  32,   0 }, {  33,   0 }, {  34,   0 }, {  35,   0 },
 {  36,   0 }, {  37,   0 }, {  38,   0 }, {  39,   0 }, {  40,   0 },
 {  41,   0 }, {  42,   0 }, {  43,   0 }, {  44,   0 }, {  45,   0 },
 {  46,   0 }, {  47,   0 }, {  48,   0 }, {  49,   0 }, {  50,   0 },
 {  51,   0 }, {  52,   0 }, {  53,   0 }, {  54,   0 }, {  55,   0 },
 {  56,   0 }, {  57,   0 }, {  58,   0 }, {  59,   0 }, {  60,   0 },
 {  61,   0 }, {  62,   0 }, {  63,   0 }, {  64,   0 }, {  65,   0 },
 {  66,   0 }, {  67,   0 }, {  68,   0 }, {  69,   0 }, {  70,   0 },
 {  71,   0 }, {  72,   0 }, {  73,   0 }, {  74,   0 }, {  75,   0 },

 {  76,   0 }, {  77,   0 }, {  78,   0 }, {  79,   0 }, {  80,   0 },
 {  81,   0 }, {  82,   0 }, {  83,   0 }, {  84,   0 }, {  85,   0 },
 {  86,   0 }, {  87,   0 }, {  88,   0 }, {  89,   0 }, {  90,   0 },
 {  91,   0 }, {  92,   0 }, {  93,   0 }, {  94,   0 }, {  95,   0 },
 {  96,   0 }, {  97,   0 }, {  98,   0 }, {  99,   0 }, { 100,   0 },
 { 101,   0 }, { 102,   0 }, { 103,   0 }, { 104,   0 }, { 105,   0 },
 { 106,   0 }, { 107,   0 }, { 108,   0 }, { 109,   0 }, { 110,   0 },
 { 111,   0 }, { 112,   0 }, { 113,   0 }, { 114,   0 }, { 115,   0 },
 { 116,   0 }, { 117,   0 }, { 118,   0 }, { 119,   0 }, { 120,   0 },
 { 121,   0 }, { 122,   0 }, { 123,   0 }, { 124,   0 }, { 125,   0 },

 { 126,   0 }, { 127,   0 }, { 128,   0 }, { 129,   0 }, { 130,   0 },
 { 131,   0 }, { 132,   0 }, { 133,   0 }, { 134,   0 }, { 135,   0 },
 { 136,   0 }, { 137,   0 }, { 138,   0 }, { 139,   0 }, { 140,   0 },
 { 141,   0 }, { 142,   0 }, { 143,   0 }, { 144,   0 }, { 145,   0 },
 { 146,   0 }, { 147,   0 }, { 148,   0 }, { 149,   0 }, { 150,   0 },
 { 151,   0 }, { 152,   0 }, { 153,   0 }, { 154,   0 }, { 155,   0 },
 { 156,   0 }, { 157,   0 }, { 158,   0 }, { 159,   0 }, { 160,   0 },
 { 161,   0 }, { 162,   0 }, { 163,   0 }, { 164,   0 }, { 165,   0 },
 { 166,   0 }, { 167,   0 }, { 168,   0 }, { 169,   0 }, { 170,   0 },
 { 171,   0 }, { 172,   0 }, { 173,   0 }, { 174,   0 }, { 175,   0 },

 { 176,   0 }, { 177,   0 }, { 178,   0 }, { 179,   0 }, { 180,   0 },
 { 181,   0 }, { 182,   0 }, { 183,   0 }, { 184,   0 }, { 185,   0 },
 { 186,   0 }, { 187,   0 }, { 188,   0 }, { 189,   0 }, { 190,   0 },
 { 191,   0 }, { 192,   0 }, { 193,   0 }, { 194,   0 }, { 195,   0 },
 { 196,   0 }, { 197,   0 }, { 198,   0 }, { 199,   0 }, { 200,   0 },
 { 201,   0 }, { 202,   0 }, { 203,   0 }, { 204,   0 }, { 205,   0 },
 { 206,   0 }, { 207,   0 }, { 208,   0 }, { 209,   0 }, { 210,   0 },
 { 211,   0 }, { 212,   0 }, { 213,   0 }, { 214,   0 }, { 215,   0 },
 { 216,   0 }, { 217,   0 }, { 218,   0 }, { 219,   0 }, { 220,   0 },
 { 221,   0 }, { 222,   0 }, { 223,   0 }, { 224,   0 }, { 225,   0 },

 { 226,   0 }, { 227,   0 }, { 228,   0 }, { 229,   0 }, { 230,   0 },
 { 231,   0 }, { 232,   0 }, { 233,   0 }, { 234,   0 }, { 235,   0 },
 { 236,   0 }, { 237,   0 }, { 238,   0 }, { 239,   0 }, { 240,   0 },
 { 241,   0 }, { 242,   0 }, { 243,   0 }, { 244,   0 }, { 245,   0 },
 { 246,   0 }, { 247,   0 }, { 248,   0 }, { 249,   0 }, { 250,   0 },
 { 251,   0 }, { 252,   0 }, { 253,   0 }, { 254,   0 }, { 255,   0 },
 { 256,   0 }, {   0,  16 }, {   0,3195 }, {   1, 371 }, {   2, 371 },
 {   3, 371 }, {   4, 371 }, {   5, 371 }, {   6, 371 }, {   7, 371 },
 {   8, 371 }, {   9, 371 }, {  10, 262 }, {  11, 371 }, {  12, 371 },
 {  13, 371 }, {  14, 371 }, {  15, 371 }, {  16, 371 }, {  17, 371 },

 {  18, 371 }, {  19, 371 }, {  20, 371 }, {  21, 371 }, {  22, 371 },
 {  23, 371 }, {  24, 371 }, {  25, 371 }, {  26, 371 }, {  27, 371 },
 {  28, 371 }, {  29, 371 }, {  30, 371 }, {  31, 371 }, {  32, 371 },
 {  33, 371 }, {  34, 371 }, {  35, 371 }, {  36, 371 }, {  37, 371 },
 {  38, 371 }, {  39, 371 }, {  40, 371 }, {  41, 371 }, {  42, 371 },
 {  43, 371 }, {  44, 371 }, {  45, 371 }, {  46, 371 }, {  47, 371 },
 {  48, 371 }, {  49, 371 }, {  50, 371 }, {  51, 371 }, {  52, 371 },
 {  53, 371 }, {  54, 371 }, {  55, 371 }, {  56, 371 }, {  57, 371 },
 {  58, 371 }, {  59, 371 }, {  60, 371 }, {  61, 371 }, {  62, 371 },
 {  63, 371 }, {  64, 371 }, {  65, 371 }, {  66, 371 }, {  67, 371 },

 {  68, 371 }, {  69, 371 }, {  70, 371 }, {  71, 371 }, {  72, 371 },
 {  73, 371 }, {  74, 371 }, {  75, 371 }, {  76, 371 }, {  77, 371 },
 {  78, 371 }, {  79, 371 }, {  80, 371 }, {  81, 371 }, {  82, 371 },
 {  83, 371 }, {  84, 371 }, {  85, 371 }, {  86, 371 }, {  87, 371 },
 {  88, 371 }, {  89, 371 }, {  90, 371 }, {  91, 371 }, {  92, 371 },
 {  93, 371 }, {  94, 371 }, {  95, 371 }, {  96, 371 }, {  97, 371 },
 {  98, 371 }, {  99, 371 }, { 100, 371 }, { 101, 371 }, { 102, 371 },
 { 103, 371 }, { 104, 371 }, { 105, 371 }, { 106, 371 }, { 107, 371 },
 { 108, 371 }, { 109, 371 }, { 110, 371 }, { 111, 371 }, { 112, 371 },
 { 113, 371 }, { 114, 371 }, { 115, 371 }, { 116, 371 }, { 117, 371 },

 { 118, 371 }, { 119, 371 }, { 120, 371 }, { 121, 371 }, { 122, 371 },
 { 123, 371 }, { 124, 371 }, { 125, 371 }, { 126, 371 }, { 127, 371 },
 { 128, 371 }, { 129, 371 }, { 130, 371 }, { 131, 371 }, { 132, 371 },
 { 133, 371 }, { 134, 371 }, { 135, 371 }, { 136, 371 }, { 137, 371 },
 { 138, 371 }, { 139, 371 }, { 140, 371 }, { 141, 371 }, { 142, 371 },
 { 143, 371 }, { 144, 371 }, { 145, 371 }, { 146, 371 }, { 147, 371 },
 { 148, 371 }, { 149, 371 }, { 150, 371 }, { 151, 371 }, { 152, 371 },
 { 153, 371 }, { 154, 371 }, { 155, 371 }, { 156, 371 }, { 157, 371 },
 { 158, 371 }, { 159, 371 }, { 160, 371 }, { 161, 371 }, { 162, 371 },
 { 163, 371 }, { 164, 371 }, { 165, 371 }, { 166, 371 }, { 167, 371 },

 { 168, 371 }, { 169, 371 }, { 170, 371 }, { 171, 371 }, { 172, 371 },
 { 173, 371 }, { 174, 371 }, { 175, 371 }, { 176, 371 }, { 177, 371 },
 { 178, 371 }, { 179, 371 }, { 180, 371 }, { 181, 371 }, { 182, 371 },
 { 183, 371 }, { 184, 371 }, { 185, 371 }, { 186, 371 }, { 187, 371 },
 { 188, 371 }, { 189, 371 }, { 190, 371 }, { 191, 371 }, { 192, 371 },
 { 193, 371 }, { 194, 371 }, { 195, 371 }, { 196, 371 }, { 197, 371 },
 { 198, 371 }, { 199, 371 }, { 200, 371 }, { 201, 371 }, { 202, 371 },
 { 203, 371 }, { 204, 371 }, { 205, 371 }, { 206, 371 }, { 207, 371 },
 { 208, 371 }, { 209, 371 }, { 210, 371 }, { 211, 371 }, { 212, 371 },
 { 213, 371 }, { 214, 371 }, { 215, 371 }, { 216, 371 }, { 217, 371 },

 { 218, 371 }, { 219, 371 }, { 220, 371 }, { 221, 371 }, { 222, 371 },
 { 223, 371 }, { 224, 371 }, { 225, 371 }, { 226, 371 }, { 227, 371 },
 { 228, 371 }, { 229, 371 }, { 230, 371 }, { 231, 371 }, { 232, 371 },
 { 233, 371 }, { 234, 371 }, { 235, 371 }, { 236, 371 }, { 237, 371 },
 { 238, 371 }, { 239, 371 }, { 240, 371 }, { 241, 371 }, { 242, 371 },
 { 243, 371 }, { 244, 371 }, { 245, 371 }, { 246, 371 }, { 247, 371 },
 { 248, 371 }, { 249, 371 }, { 250, 371 }, { 251, 371 }, { 252, 371 },
 { 253, 371 }, { 254, 371 }, { 255, 371 }, { 256, 371 }, {   0,  47 },
 {   0,2937 }, {   0,   4 }, {   0,2935 }, {   0,  17 }, {   0,2933 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },

 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },

 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {  79, 371 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },

 {   0,   0 }, { 111, 371 }, {   0,  18 }, {   0,2824 }, {   1,   0 },
 {   2,   0 }, {   3,   0 }, {   4,   0 }, {   5,   0 }, {   6,   0 },
 {   7,   0 }, {   8,   0 }, {   9,   0 }, {  10, 260 }, {  11,   0 },
 {  12,   0 }, {  13,   0 }, {  14,   0 }, {  15,   0 }, {  16,   0 },
 {  17,   0 }, {  18,   0 }, {  19,   0 }, {  20,   0 }, {  21,   0 },
 {  22,   0 }, {  23,   0 }, {  24,   0 }, {  25,   0 }, {  26,   0 },
 {  27,   0 }, {  28,   0 }, {  29,   0 }, {  30,   0 }, {  31,   0 },
 {  32,   0 }, {  33,   0 }, {  34,   0 }, {  35,   0 }, {  36,   0 },
 {  37,   0 }, {  38,   0 }, {  39,   0 }, {  40,   0 }, {  41,   0 },
 {  42,   0 }, {  43,   0 }, {  44,   0 }, {  45,   0 }, {  46,   0 },

 {  47,   0 }, {  48,   0 }, {  49,   0 }, {  50,   0 }, {  51,   0 },
 {  52,   0 }, {  53,   0 }, {  54,   0 }, {  55,   0 }, {  56,   0 },
 {  57,   0 }, {  58,   0 }, {  59,   0 }, {  60,   0 }, {  61,   0 },
 {  62,   0 }, {  63,   0 }, {  64,   0 }, {  65,   0 }, {  66,   0 },
 {  67,   0 }, {  68,   0 }, {  69,   0 }, {  70,   0 }, {  71,   0 },
 {  72,   0 }, {  73,   0 }, {  74,   0 }, {  75,   0 }, {  76,   0 },
 {  77,   0 }, {  78,   0 }, {  79,   0 }, {  80,   0 }, {  81,   0 },
 {  82,   0 }, {  83,   0 }, {  84,   0 }, {  85,   0 }, {  86,   0 },
 {  87,   0 }, {  88,   0 }, {  89,   0 }, {  90,   0 }, {  91,   0 },
 {  92,   0 }, {  93,   0 }, {  94,   0 }, {  95,   0 }, {  96,   0 },

 {  97,   0 }, {  98,   0 }, {  99,   0 }, { 100,   0 }, { 101,   0 },
 { 102,   0 }, { 103,   0 }, { 104,   0 }, { 105,   0 }, { 106,   0 },
 { 107,   0 }, { 108,   0 }, { 109,   0 }, { 110,   0 }, { 111,   0 },
 { 112,   0 }, { 113,   0 }, { 114,   0 }, { 115,   0 }, { 116,   0 },
 { 117,   0 }, { 118,   0 }, { 119,   0 }, { 120,   0 }, { 121,   0 },
 { 122,   0 }, { 123,   0 }, { 124,   0 }, { 125,   0 }, { 126,   0 },
 { 127,   0 }, { 128,   0 }, { 129,   0 }, { 130,   0 }, { 131,   0 },
 { 132,   0 }, { 133,   0 }, { 134,   0 }, { 135,   0 }, { 136,   0 },
 { 137,   0 }, { 138,   0 }, { 139,   0 }, { 140,   0 }, { 141,   0 },
 { 142,   0 }, { 143,   0 }, { 144,   0 }, { 145,   0 }, { 146,   0 },

 { 147,   0 }, { 148,   0 }, { 149,   0 }, { 150,   0 }, { 151,   0 },
 { 152,   0 }, { 153,   0 }, { 154,   0 }, { 155,   0 }, { 156,   0 },
 { 157,   0 }, { 158,   0 }, { 159,   0 }, { 160,   0 }, { 161,   0 },
 { 162,   0 }, { 163,   0 }, { 164,   0 }, { 165,   0 }, { 166,   0 },
 { 167,   0 }, { 168,   0 }, { 169,   0 }, { 170,   0 }, { 171,   0 },
 { 172,   0 }, { 173,   0 }, { 174,   0 }, { 175,   0 }, { 176,   0 },
 { 177,   0 }, { 178,   0 }, { 179,   0 }, { 180,   0 }, { 181,   0 },
 { 182,   0 }, { 183,   0 }, { 184,   0 }, { 185,   0 }, { 186,   0 },
 { 187,   0 }, { 188,   0 }, { 189,   0 }, { 190,   0 }, { 191,   0 },
 { 192,   0 }, { 193,   0 }, { 194,   0 }, { 195,   0 }, { 196,   0 },

 { 197,   0 }, { 198,   0 }, { 199,   0 }, { 200,   0 }, { 201,   0 },
 { 202,   0 }, { 203,   0 }, { 204,   0 }, { 205,   0 }, { 206,   0 },
 { 207,   0 }, { 208,   0 }, { 209,   0 }, { 210,   0 }, { 211,   0 },
 { 212,   0 }, { 213,   0 }, { 214,   0 }, { 215,   0 }, { 216,   0 },
 { 217,   0 }, { 218,   0 }, { 219,   0 }, { 220,   0 }, { 221,   0 },
 { 222,   0 }, { 223,   0 }, { 224,   0 }, { 225,   0 }, { 226,   0 },
 { 227,   0 }, { 228,   0 }, { 229,   0 }, { 230,   0 }, { 231,   0 },
 { 232,   0 }, { 233,   0 }, { 234,   0 }, { 235,   0 }, { 236,   0 },
 { 237,   0 }, { 238,   0 }, { 239,   0 }, { 240,   0 }, { 241,   0 },
 { 242,   0 }, { 243,   0 }, { 244,   0 }, { 245,   0 }, { 246,   0 },

 { 247,   0 }, { 248,   0 }, { 249,   0 }, { 250,   0 }, { 251,   0 },
 { 252,   0 }, { 253,   0 }, { 254,   0 }, { 255,   0 }, { 256,   0 },
 {   0,  46 }, {   0,2566 }, {   0,  19 }, {   0,2564 }, {   0,  42 },
 {   0,2562 }, {   0,  44 }, {   0,2560 }, {   0,  43 }, {   0,2558 },
 {   0,  41 }, {   0,2556 }, {   0,  39 }, {   0,2554 }, {   0,   0 },
 {  10,   4 }, {   0,  40 }, {   0,2550 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },

 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {  78, 112 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },

 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, { 110, 112 }, {   0,  45 }, {   0,2454 }, {   1,-108 },
 {   2,-108 }, {   3,-108 }, {   4,-108 }, {   5,-108 }, {   6,-108 },
 {   7,-108 }, {   8,-108 }, {   9,-108 }, {  10,-106 }, {  11,-108 },
 {  12,-108 }, {  13,-108 }, {  14,-108 }, {  15,-108 }, {  16,-108 },
 {  17,-108 }, {  18,-108 }, {  19,-108 }, {  20,-108 }, {  21,-108 },
 {  22,-108 }, {  23,-108 }, {  24,-108 }, {  25,-108 }, {  26,-108 },

 {  27,-108 }, {  28,-108 }, {  29,-108 }, {  30,-108 }, {  31,-108 },
 {  32,-108 }, {  33,-108 }, {  34,-108 }, {  35,-108 }, {  36,-108 },
 {  37,-108 }, {  38,-108 }, {  39,-108 }, {  40,-108 }, {  41,-108 },
 {  42,-108 }, {  43,-108 }, {  44,-108 }, {  45,-108 }, {  46,-108 },
 {  47,-108 }, {  48,-108 }, {  49,-108 }, {  50,-108 }, {  51,-108 },
 {  52,-108 }, {  53,-108 }, {  54,-108 }, {  55,-108 }, {  56,-108 },
 {  57,-108 }, {  58, 258 }, {  59,-108 }, {  60,-108 }, {  61,-108 },
 {  62,-108 }, {  63,-108 }, {  64,-108 }, {  65,-108 }, {  66,-108 },
 {  67,-108 }, {  68,-108 }, {  69,-108 }, {  70,-108 }, {  71,-108 },
 {  72,-108 }, {  73,-108 }, {  74,-108 }, {  75,-108 }, {  76,-108 },

 {  77,-108 }, {  78,-108 }, {  79,-108 }, {  80,-108 }, {  81,-108 },
 {  82,-108 }, {  83,-108 }, {  84,-108 }, {  85,-108 }, {  86,-108 },
 {  87,-108 }, {  88,-108 }, {  89,-108 }, {  90,-108 }, {  91,-108 },
 {  92,-108 }, {  93,-108 }, {  94,-108 }, {  95,-108 }, {  96,-108 },
 {  97,-108 }, {  98,-108 }, {  99,-108 }, { 100,-108 }, { 101,-108 },
 { 102,-108 }, { 103,-108 }, { 104,-108 }, { 105,-108 }, { 106,-108 },
 { 107,-108 }, { 108,-108 }, { 109,-108 }, { 110,-108 }, { 111,-108 },
 { 112,-108 }, { 113,-108 }, { 114,-108 }, { 115,-108 }, { 116,-108 },
 { 117,-108 }, { 118,-108 }, { 119,-108 }, { 120,-108 }, { 121,-108 },
 { 122,-108 }, { 123,-108 }, { 124,-108 }, { 125,-108 }, { 126,-108 },

 { 127,-108 }, { 128,-108 }, { 129,-108 }, { 130,-108 }, { 131,-108 },
 { 132,-108 }, { 133,-108 }, { 134,-108 }, { 135,-108 }, { 136,-108 },
 { 137,-108 }, { 138,-108 }, { 139,-108 }, { 140,-108 }, { 141,-108 },
 { 142,-108 }, { 143,-108 }, { 144,-108 }, { 145,-108 }, { 146,-108 },
 { 147,-108 }, { 148,-108 }, { 149,-108 }, { 150,-108 }, { 151,-108 },
 { 152,-108 }, { 153,-108 }, { 154,-108 }, { 155,-108 }, { 156,-108 },
 { 157,-108 }, { 158,-108 }, { 159,-108 }, { 160,-108 }, { 161,-108 },
 { 162,-108 }, { 163,-108 }, { 164,-108 }, { 165,-108 }, { 166,-108 },
 { 167,-108 }, { 168,-108 }, { 169,-108 }, { 170,-108 }, { 171,-108 },
 { 172,-108 }, { 173,-108 }, { 174,-108 }, { 175,-108 }, { 176,-108 },

 { 177,-108 }, { 178,-108 }, { 179,-108 }, { 180,-108 }, { 181,-108 },
 { 182,-108 }, { 183,-108 }, { 184,-108 }, { 185,-108 }, { 186,-108 },
 { 187,-108 }, { 188,-108 }, { 189,-108 }, { 190,-108 }, { 191,-108 },
 { 192,-108 }, { 193,-108 }, { 194,-108 }, { 195,-108 }, { 196,-108 },
 { 197,-108 }, { 198,-108 }, { 199,-108 }, { 200,-108 }, { 201,-108 },
 { 202,-108 }, { 203,-108 }, { 204,-108 }, { 205,-108 }, { 206,-108 },
 { 207,-108 }, { 208,-108 }, { 209,-108 }, { 210,-108 }, { 211,-108 },
 { 212,-108 }, { 213,-108 }, { 214,-108 }, { 215,-108 }, { 216,-108 },
 { 217,-108 }, { 218,-108 }, { 219,-108 }, { 220,-108 }, { 221,-108 },
 { 222,-108 }, { 223,-108 }, { 224,-108 }, { 225,-108 }, { 226,-108 },

 { 227,-108 }, { 228,-108 }, { 229,-108 }, { 230,-108 }, { 231,-108 },
 { 232,-108 }, { 233,-108 }, { 234,-108 }, { 235,-108 }, { 236,-108 },
 { 237,-108 }, { 238,-108 }, { 239,-108 }, { 240,-108 }, { 241,-108 },
 { 242,-108 }, { 243,-108 }, { 244,-108 }, { 245,-108 }, { 246,-108 },
 { 247,-108 }, { 248,-108 }, { 249,-108 }, { 250,-108 }, { 251,-108 },
 { 252,-108 }, { 253,-108 }, { 254,-108 }, { 255,-108 }, { 256,-108 },
 {   0,  42 }, {   0,2196 }, {   1,-360 }, {   2,-360 }, {   3,-360 },
 {   4,-360 }, {   5,-360 }, {   6,-360 }, {   7,-360 }, {   8,-360 },
 {   9,-360 }, {  10,-362 }, {  11,-360 }, {  12,-360 }, {  13,-360 },
 {  14,-360 }, {  15,-360 }, {  16,-360 }, {  17,-360 }, {  18,-360 },

 {  19,-360 }, {  20,-360 }, {  21,-360 }, {  22,-360 }, {  23,-360 },
 {  24,-360 }, {  25,-360 }, {  26,-360 }, {  27,-360 }, {  28,-360 },
 {  29,-360 }, {  30,-360 }, {  31,-360 }, {  32, 258 }, {  33,-360 },
 {  34,-360 }, {  35,-360 }, {  36,-360 }, {  37,-360 }, {  38,-360 },
 {  39,-360 }, {  40,-360 }, {  41,-360 }, {  42,-360 }, {  43,-360 },
 {  44,-360 }, {  45,-360 }, {  46,-360 }, {  47,-360 }, {  48,-360 },
 {  49,-360 }, {  50,-360 }, {  51,-360 }, {  52,-360 }, {  53,-360 },
 {  54,-360 }, {  55,-360 }, {  56,-360 }, {  57,-360 }, {  58,-360 },
 {  59,-360 }, {  60,-360 }, {  61,-360 }, {  62,-360 }, {  63,-360 },
 {  64,-360 }, {  65,-360 }, {  66,-360 }, {  67,-360 }, {  68,-360 },

 {  69,-360 }, {  70,-360 }, {  71,-360 }, {  72,-360 }, {  73,-360 },
 {  74,-360 }, {  75,-360 }, {  76,-360 }, {  77,-360 }, {  78,-360 },
 {  79,-360 }, {  80,-360 }, {  81,-360 }, {  82,-360 }, {  83,-360 },
 {  84,-360 }, {  85,-360 }, {  86,-360 }, {  87,-360 }, {  88,-360 },
 {  89,-360 }, {  90,-360 }, {  91,-360 }, {  92,-360 }, {  93,-360 },
 {  94,-360 }, {  95,-360 }, {  96,-360 }, {  97,-360 }, {  98,-360 },
 {  99,-360 }, { 100,-360 }, { 101,-360 }, { 102,-360 }, { 103,-360 },
 { 104,-360 }, { 105,-360 }, { 106,-360 }, { 107,-360 }, { 108,-360 },
 { 109,-360 }, { 110,-360 }, { 111,-360 }, { 112,-360 }, { 113,-360 },
 { 114,-360 }, { 115,-360 }, { 116,-360 }, { 117,-360 }, { 118,-360 },

 { 119,-360 }, { 120,-360 }, { 121,-360 }, { 122,-360 }, { 123,-360 },
 { 124,-360 }, { 125,-360 }, { 126,-360 }, { 127,-360 }, { 128,-360 },
 { 129,-360 }, { 130,-360 }, { 131,-360 }, { 132,-360 }, { 133,-360 },
 { 134,-360 }, { 135,-360 }, { 136,-360 }, { 137,-360 }, { 138,-360 },
 { 139,-360 }, { 140,-360 }, { 141,-360 }, { 142,-360 }, { 143,-360 },
 { 144,-360 }, { 145,-360 }, { 146,-360 }, { 147,-360 }, { 148,-360 },
 { 149,-360 }, { 150,-360 }, { 151,-360 }, { 152,-360 }, { 153,-360 },
 { 154,-360 }, { 155,-360 }, { 156,-360 }, { 157,-360 }, { 158,-360 },
 { 159,-360 }, { 160,-360 }, { 161,-360 }, { 162,-360 }, { 163,-360 },
 { 164,-360 }, { 165,-360 }, { 166,-360 }, { 167,-360 }, { 168,-360 },

 { 169,-360 }, { 170,-360 }, { 171,-360 }, { 172,-360 }, { 173,-360 },
 { 174,-360 }, { 175,-360 }, { 176,-360 }, { 177,-360 }, { 178,-360 },
 { 179,-360 }, { 180,-360 }, { 181,-360 }, { 182,-360 }, { 183,-360 },
 { 184,-360 }, { 185,-360 }, { 186,-360 }, { 187,-360 }, { 188,-360 },
 { 189,-360 }, { 190,-360 }, { 191,-360 }, { 192,-360 }, { 193,-360 },
 { 194,-360 }, { 195,-360 }, { 196,-360 }, { 197,-360 }, { 198,-360 },
 { 199,-360 }, { 200,-360 }, { 201,-360 }, { 202,-360 }, { 203,-360 },
 { 204,-360 }, { 205,-360 }, { 206,-360 }, { 207,-360 }, { 208,-360 },
 { 209,-360 }, { 210,-360 }, { 211,-360 }, { 212,-360 }, { 213,-360 },
 { 214,-360 }, { 215,-360 }, { 216,-360 }, { 217,-360 }, { 218,-360 },

 { 219,-360 }, { 220,-360 }, { 221,-360 }, { 222,-360 }, { 223,-360 },
 { 224,-360 }, { 225,-360 }, { 226,-360 }, { 227,-360 }, { 228,-360 },
 { 229,-360 }, { 230,-360 }, { 231,-360 }, { 232,-360 }, { 233,-360 },
 { 234,-360 }, { 235,-360 }, { 236,-360 }, { 237,-360 }, { 238,-360 },
 { 239,-360 }, { 240,-360 }, { 241,-360 }, { 242,-360 }, { 243,-360 },
 { 244,-360 }, { 245,-360 }, { 246,-360 }, { 247,-360 }, { 248,-360 },
 { 249,-360 }, { 250,-360 }, { 251,-360 }, { 252,-360 }, { 253,-360 },
 { 254,-360 }, { 255,-360 }, { 256,-360 }, {   0,  41 }, {   0,1938 },
 {   1,-616 }, {   2,-616 }, {   3,-616 }, {   4,-616 }, {   5,-616 },
 {   6,-616 }, {   7,-616 }, {   8,-616 }, {   9,-616 }, {  10,-612 },

 {  11,-616 }, {  12,-616 }, {  13,-616 }, {  14,-616 }, {  15,-616 },
 {  16,-616 }, {  17,-616 }, {  18,-616 }, {  19,-616 }, {  20,-616 },
 {  21,-616 }, {  22,-616 }, {  23,-616 }, {  24,-616 }, {  25,-616 },
 {  26,-616 }, {  27,-616 }, {  28,-616 }, {  29,-616 }, {  30,-616 },
 {  31,-616 }, {  32,-616 }, {  33,-616 }, {  34,-616 }, {  35,-616 },
 {  36,-616 }, {  37,-616 }, {  38,-616 }, {  39,-616 }, {  40,-616 },
 {  41,-616 }, {  42,-616 }, {  43,-616 }, {  44,-616 }, {  45,-616 },
 {  46,-616 }, {  47,-616 }, {  48,-616 }, {  49,-616 }, {  50,-616 },
 {  51,-616 }, {  52,-616 }, {  53,-616 }, {  54,-616 }, {  55,-616 },
 {  56,-616 }, {  57,-616 }, {  58,-616 }, {  59,-616 }, {  60,-616 },

 {  61,-616 }, {  62,-616 }, {  63,-616 }, {  64,-616 }, {  65, 258 },
 {  66,-616 }, {  67,-616 }, {  68, 260 }, {  69,-616 }, {  70,-616 },
 {  71,-616 }, {  72,-616 }, {  73,-616 }, {  74,-616 }, {  75,-616 },
 {  76,-616 }, {  77, 262 }, {  78,-616 }, {  79,-616 }, {  80,-616 },
 {  81,-616 }, {  82, 266 }, {  83,-616 }, {  84,-616 }, {  85,-616 },
 {  86,-616 }, {  87,-616 }, {  88,-616 }, {  89,-616 }, {  90,-616 },
 {  91,-616 }, {  92,-616 }, {  93,-616 }, {  94,-616 }, {  95,-616 },
 {  96,-616 }, {  97, 258 }, {  98,-616 }, {  99,-616 }, { 100, 260 },
 { 101,-616 }, { 102,-616 }, { 103,-616 }, { 104,-616 }, { 105,-616 },
 { 106,-616 }, { 107,-616 }, { 108,-616 }, { 109, 262 }, { 110,-616 },

 { 111,-616 }, { 112,-616 }, { 113,-616 }, { 114, 266 }, { 115,-616 },
 { 116,-616 }, { 117,-616 }, { 118,-616 }, { 119,-616 }, { 120,-616 },
 { 121,-616 }, { 122,-616 }, { 123,-616 }, { 124,-616 }, { 125,-616 },
 { 126,-616 }, { 127,-616 }, { 128,-616 }, { 129,-616 }, { 130,-616 },
 { 131,-616 }, { 132,-616 }, { 133,-616 }, { 134,-616 }, { 135,-616 },
 { 136,-616 }, { 137,-616 }, { 138,-616 }, { 139,-616 }, { 140,-616 },
 { 141,-616 }, { 142,-616 }, { 143,-616 }, { 144,-616 }, { 145,-616 },
 { 146,-616 }, { 147,-616 }, { 148,-616 }, { 149,-616 }, { 150,-616 },
 { 151,-616 }, { 152,-616 }, { 153,-616 }, { 154,-616 }, { 155,-616 },
 { 156,-616 }, { 157,-616 }, { 158,-616 }, { 159,-616 }, { 160,-616 },

 { 161,-616 }, { 162,-616 }, { 163,-616 }, { 164,-616 }, { 165,-616 },
 { 166,-616 }, { 167,-616 }, { 168,-616 }, { 169,-616 }, { 170,-616 },
 { 171,-616 }, { 172,-616 }, { 173,-616 }, { 174,-616 }, { 175,-616 },
 { 176,-616 }, { 177,-616 }, { 178,-616 }, { 179,-616 }, { 180,-616 },
 { 181,-616 }, { 182,-616 }, { 183,-616 }, { 184,-616 }, { 185,-616 },
 { 186,-616 }, { 187,-616 }, { 188,-616 }, { 189,-616 }, { 190,-616 },
 { 191,-616 }, { 192,-616 }, { 193,-616 }, { 194,-616 }, { 195,-616 },
 { 196,-616 }, { 197,-616 }, { 198,-616 }, { 199,-616 }, { 200,-616 },
 { 201,-616 }, { 202,-616 }, { 203,-616 }, { 204,-616 }, { 205,-616 },
 { 206,-616 }, { 207,-616 }, { 208,-616 }, { 209,-616 }, { 210,-616 },

 { 211,-616 }, { 212,-616 }, { 213,-616 }, { 214,-616 }, { 215,-616 },
 { 216,-616 }, { 217,-616 }, { 218,-616 }, { 219,-616 }, { 220,-616 },
 { 221,-616 }, { 222,-616 }, { 223,-616 }, { 224,-616 }, { 225,-616 },
 { 226,-616 }, { 227,-616 }, { 228,-616 }, { 229,-616 }, { 230,-616 },
 { 231,-616 }, { 232,-616 }, { 233,-616 }, { 234,-616 }, { 235,-616 },
 { 236,-616 }, { 237,-616 }, { 238,-616 }, { 239,-616 }, { 240,-616 },
 { 241,-616 }, { 242,-616 }, { 243,-616 }, { 244,-616 }, { 245,-616 },
 { 246,-616 }, { 247,-616 }, { 248,-616 }, { 249,-616 }, { 250,-616 },
 { 251,-616 }, { 252,-616 }, { 253,-616 }, { 254,-616 }, { 255,-616 },
 { 256,-616 }, {   0,  39 }, {   0,1680 }, {   0,  39 }, {   0,1678 },

 {   0,  39 }, {   0,1676 }, {   0,   0 }, {   0,   0 }, {   0,  39 },
 {   0,1672 }, {   0,  23 }, {   0,1670 }, {   0,  38 }, {   0,1668 },
 {   0,  33 }, {   0,1666 }, {   0,  27 }, {   0,1664 }, {   0,  22 },
 {   0,1662 }, {   0,  37 }, {   0,1660 }, {   0,  32 }, {   0,1658 },
 {   0,  26 }, {   0,1656 }, {   0,  21 }, {   0,1654 }, {   0,   0 },
 {   0,  36 }, {   0,1651 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,  31 }, {   0,1646 }, {   0,  25 }, {   0,1644 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },

 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {  73,  10 }, {  76,  10 }, {  69,   8 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {  68,   8 },
 {  79,  10 }, {   0,   0 }, {   0,   0 }, {  76,   8 }, {  67,   9 },
 {   0,   0 }, {   0,   0 }, {  74,   8 }, {  69,  12 }, {   0,   0 },
 {  69,  12 }, {  65, 379 }, {  83,   8 }, {   0,   0 }, {  79,   8 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },

 {  67, 376 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, { 105,  10 },
 { 108,  10 }, { 101,   8 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {  87, 124 }, { 100,   8 }, { 111,  10 }, {  82, 376 }, {   0,   0 },
 { 108,   8 }, {  99,   9 }, {   0,   0 }, {   0,   0 }, { 106,   8 },
 { 101,  12 }, {   0,   0 }, { 101,  12 }, {  97, 379 }, { 115,   8 },
 {   0,   0 }, { 111,   8 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {  99, 376 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, { 119, 124 }, {   0,   0 }, {   0,   0 },
 { 114, 376 }, {   0,  52 }, {   0,1530 }, {   1, 380 }, {   2, 380 },

 {   3, 380 }, {   4, 380 }, {   5, 380 }, {   6, 380 }, {   7, 380 },
 {   8, 380 }, {   9, 380 }, {  10, 264 }, {  11, 380 }, {  12, 380 },
 {  13, 380 }, {  14, 380 }, {  15, 380 }, {  16, 380 }, {  17, 380 },
 {  18, 380 }, {  19, 380 }, {  20, 380 }, {  21, 380 }, {  22, 380 },
 {  23, 380 }, {  24, 380 }, {  25, 380 }, {  26, 380 }, {  27, 380 },
 {  28, 380 }, {  29, 380 }, {  30, 380 }, {  31, 380 }, {  32, 380 },
 {  33, 380 }, {  34, 380 }, {  35, 380 }, {  36, 380 }, {  37, 380 },
 {  38, 380 }, {  39, 380 }, {  40, 380 }, {  41, 380 }, {  42, 380 },
 {  43, 380 }, {  44, 380 }, {  45, 380 }, {  46, 380 }, {  47, 380 },
 {  48, 380 }, {  49, 380 }, {  50, 380 }, {  51, 380 }, {  52, 380 },

 {  53, 380 }, {  54, 380 }, {  55, 380 }, {  56, 380 }, {  57, 380 },
 {  58, 380 }, {  59, 380 }, {  60, 380 }, {  61, 380 }, {  62, 380 },
 {  63, 380 }, {  64, 380 }, {  65, 380 }, {  66, 380 }, {  67, 380 },
 {  68, 380 }, {  69, 380 }, {  70, 380 }, {  71, 380 }, {  72, 380 },
 {  73, 380 }, {  74, 380 }, {  75, 380 }, {  76, 380 }, {  77, 380 },
 {  78, 380 }, {  79, 380 }, {  80, 380 }, {  81, 380 }, {  82, 380 },
 {  83, 380 }, {  84, 380 }, {  85, 380 }, {  86, 380 }, {  87, 380 },
 {  88, 380 }, {  89, 380 }, {  90, 380 }, {  91, 380 }, {  92, 380 },
 {  93, 380 }, {  94, 380 }, {  95, 380 }, {  96, 380 }, {  97, 380 },
 {  98, 380 }, {  99, 380 }, { 100, 380 }, { 101, 380 }, { 102, 380 },

 { 103, 380 }, { 104, 380 }, { 105, 380 }, { 106, 380 }, { 107, 380 },
 { 108, 380 }, { 109, 380 }, { 110, 380 }, { 111, 380 }, { 112, 380 },
 { 113, 380 }, { 114, 380 }, { 115, 380 }, { 116, 380 }, { 117, 380 },
 { 118, 380 }, { 119, 380 }, { 120, 380 }, { 121, 380 }, { 122, 380 },
 { 123, 380 }, { 124, 380 }, { 125, 380 }, { 126, 380 }, { 127, 380 },
 { 128, 380 }, { 129, 380 }, { 130, 380 }, { 131, 380 }, { 132, 380 },
 { 133, 380 }, { 134, 380 }, { 135, 380 }, { 136, 380 }, { 137, 380 },
 { 138, 380 }, { 139, 380 }, { 140, 380 }, { 141, 380 }, { 142, 380 },
 { 143, 380 }, { 144, 380 }, { 145, 380 }, { 146, 380 }, { 147, 380 },
 { 148, 380 }, { 149, 380 }, { 150, 380 }, { 151, 380 }, { 152, 380 },

 { 153, 380 }, { 154, 380 }, { 155, 380 }, { 156, 380 }, { 157, 380 },
 { 158, 380 }, { 159, 380 }, { 160, 380 }, { 161, 380 }, { 162, 380 },
 { 163, 380 }, { 164, 380 }, { 165, 380 }, { 166, 380 }, { 167, 380 },
 { 168, 380 }, { 169, 380 }, { 170, 380 }, { 171, 380 }, { 172, 380 },
 { 173, 380 }, { 174, 380 }, { 175, 380 }, { 176, 380 }, { 177, 380 },
 { 178, 380 }, { 179, 380 }, { 180, 380 }, { 181, 380 }, { 182, 380 },
 { 183, 380 }, { 184, 380 }, { 185, 380 }, { 186, 380 }, { 187, 380 },
 { 188, 380 }, { 189, 380 }, { 190, 380 }, { 191, 380 }, { 192, 380 },
 { 193, 380 }, { 194, 380 }, { 195, 380 }, { 196, 380 }, { 197, 380 },
 { 198, 380 }, { 199, 380 }, { 200, 380 }, { 201, 380 }, { 202, 380 },

 { 203, 380 }, { 204, 380 }, { 205, 380 }, { 206, 380 }, { 207, 380 },
 { 208, 380 }, { 209, 380 }, { 210, 380 }, { 211, 380 }, { 212, 380 },
 { 213, 380 }, { 214, 380 }, { 215, 380 }, { 216, 380 }, { 217, 380 },
 { 218, 380 }, { 219, 380 }, { 220, 380 }, { 221, 380 }, { 222, 380 },
 { 223, 380 }, { 224, 380 }, { 225, 380 }, { 226, 380 }, { 227, 380 },
 { 228, 380 }, { 229, 380 }, { 230, 380 }, { 231, 380 }, { 232, 380 },
 { 233, 380 }, { 234, 380 }, { 235, 380 }, { 236, 380 }, { 237, 380 },
 { 238, 380 }, { 239, 380 }, { 240, 380 }, { 241, 380 }, { 242, 380 },
 { 243, 380 }, { 244, 380 }, { 245, 380 }, { 246, 380 }, { 247, 380 },
 { 248, 380 }, { 249, 380 }, { 250, 380 }, { 251, 380 }, { 252, 380 },

 { 253, 380 }, { 254, 380 }, { 255, 380 }, { 256, 380 }, {   0,  35 },
 {   0,1272 }, {   0,  30 }, {   0,1270 }, {   0,  24 }, {   0,1268 },
 {   0,  53 }, {   0,1266 }, {   0,  34 }, {   0,1264 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },

 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {  65, 378 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {  68, 748 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {  82,   8 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {  84, 494 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },

 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {  97, 378 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, { 100, 748 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, { 114,   8 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 { 116, 494 }, {   0,  52 }, {   0,1150 }, {   1,   0 }, {   2,   0 },
 {   3,   0 }, {   4,   0 }, {   5,   0 }, {   6,   0 }, {   7,   0 },
 {   8,   0 }, {   9,   0 }, {  10,-116 }, {  11,   0 }, {  12,   0 },
 {  13,   0 }, {  14,   0 }, {  15,   0 }, {  16,   0 }, {  17,   0 },
 {  18,   0 }, {  19,   0 }, {  20,   0 }, {  21,   0 }, {  22,   0 },

 {  23,   0 }, {  24,   0 }, {  25,   0 }, {  26,   0 }, {  27,   0 },
 {  28,   0 }, {  29,   0 }, {  30,   0 }, {  31,   0 }, {  32,   0 },
 {  33,   0 }, {  34,   0 }, {  35,   0 }, {  36,   0 }, {  37,   0 },
 {  38,   0 }, {  39,   0 }, {  40,   0 }, {  41,   0 }, {  42,   0 },
 {  43,   0 }, {  44,   0 }, {  45,   0 }, {  46,   0 }, {  47,   0 },
 {  48,   0 }, {  49,   0 }, {  50,   0 }, {  51,   0 }, {  52,   0 },
 {  53,   0 }, {  54,   0 }, {  55,   0 }, {  56,   0 }, {  57,   0 },
 {  58,   0 }, {  59,   0 }, {  60,   0 }, {  61,   0 }, {  62,   0 },
 {  63,   0 }, {  64,   0 }, {  65,   0 }, {  66,   0 }, {  67,   0 },
 {  68,   0 }, {  69,   0 }, {  70,   0 }, {  71,   0 }, {  72,   0 },

 {  73,   0 }, {  74,   0 }, {  75,   0 }, {  76,   0 }, {  77,   0 },
 {  78,   0 }, {  79,   0 }, {  80,   0 }, {  81,   0 }, {  82,   0 },
 {  83,   0 }, {  84,   0 }, {  85,   0 }, {  86,   0 }, {  87,   0 },
 {  88,   0 }, {  89,   0 }, {  90,   0 }, {  91,   0 }, {  92,   0 },
 {  93,   0 }, {  94,   0 }, {  95,   0 }, {  96,   0 }, {  97,   0 },
 {  98,   0 }, {  99,   0 }, { 100,   0 }, { 101,   0 }, { 102,   0 },
 { 103,   0 }, { 104,   0 }, { 105,   0 }, { 106,   0 }, { 107,   0 },
 { 108,   0 }, { 109,   0 }, { 110,   0 }, { 111,   0 }, { 112,   0 },
 { 113,   0 }, { 114,   0 }, { 115,   0 }, { 116,   0 }, { 117,   0 },
 { 118,   0 }, { 119,   0 }, { 120,   0 }, { 121,   0 }, { 122,   0 },

 { 123,   0 }, { 124,   0 }, { 125,   0 }, { 126,   0 }, { 127,   0 },
 { 128,   0 }, { 129,   0 }, { 130,   0 }, { 131,   0 }, { 132,   0 },
 { 133,   0 }, { 134,   0 }, { 135,   0 }, { 136,   0 }, { 137,   0 },
 { 138,   0 }, { 139,   0 }, { 140,   0 }, { 141,   0 }, { 142,   0 },
 { 143,   0 }, { 144,   0 }, { 145,   0 }, { 146,   0 }, { 147,   0 },
 { 148,   0 }, { 149,   0 }, { 150,   0 }, { 151,   0 }, { 152,   0 },
 { 153,   0 }, { 154,   0 }, { 155,   0 }, { 156,   0 }, { 157,   0 },
 { 158,   0 }, { 159,   0 }, { 160,   0 }, { 161,   0 }, { 162,   0 },
 { 163,   0 }, { 164,   0 }, { 165,   0 }, { 166,   0 }, { 167,   0 },
 { 168,   0 }, { 169,   0 }, { 170,   0 }, { 171,   0 }, { 172,   0 },

 { 173,   0 }, { 174,   0 }, { 175,   0 }, { 176,   0 }, { 177,   0 },
 { 178,   0 }, { 179,   0 }, { 180,   0 }, { 181,   0 }, { 182,   0 },
 { 183,   0 }, { 184,   0 }, { 185,   0 }, { 186,   0 }, { 187,   0 },
 { 188,   0 }, { 189,   0 }, { 190,   0 }, { 191,   0 }, { 192,   0 },
 { 193,   0 }, { 194,   0 }, { 195,   0 }, { 196,   0 }, { 197,   0 },
 { 198,   0 }, { 199,   0 }, { 200,   0 }, { 201,   0 }, { 202,   0 },
 { 203,   0 }, { 204,   0 }, { 205,   0 }, { 206,   0 }, { 207,   0 },
 { 208,   0 }, { 209,   0 }, { 210,   0 }, { 211,   0 }, { 212,   0 },
 { 213,   0 }, { 214,   0 }, { 215,   0 }, { 216,   0 }, { 217,   0 },
 { 218,   0 }, { 219,   0 }, { 220,   0 }, { 221,   0 }, { 222,   0 },

 { 223,   0 }, { 224,   0 }, { 225,   0 }, { 226,   0 }, { 227,   0 },
 { 228,   0 }, { 229,   0 }, { 230,   0 }, { 231,   0 }, { 232,   0 },
 { 233,   0 }, { 234,   0 }, { 235,   0 }, { 236,   0 }, { 237,   0 },
 { 238,   0 }, { 239,   0 }, { 240,   0 }, { 241,   0 }, { 242,   0 },
 { 243,   0 }, { 244,   0 }, { 245,   0 }, { 246,   0 }, { 247,   0 },
 { 248,   0 }, { 249,   0 }, { 250,   0 }, { 251,   0 }, { 252,   0 },
 { 253,   0 }, { 254,   0 }, { 255,   0 }, { 256,   0 }, {   0,  29 },
 {   0, 892 }, {   0,  28 }, {   0, 890 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },

 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },

 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {  69, 632 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {  84,   2 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, { 101, 632 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },
 {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 }, {   0,   0 },

 {   0,   0 }, { 116,   2 }, {   0,  52 }, {   0, 774 }, {   1,-376 },
 {   2,-376 }, {   3,-376 }, {   4,-376 }, {   5,-376 }, {   6,-376 },
 {   7,-376 }, {   8,-376 }, {   9,-376 }, {  10,-492 }, {  11,-376 },
 {  12,-376 }, {  13,-376 }, {  14,-376 }, {  15,-376 }, {  16,-376 },
 {  17,-376 }, {  18,-376 }, {  19,-376 }, {  20,-376 }, {  21,-376 },
 {  22,-376 }, {  23,-376 }, {  24,-376 }, {  25,-376 }, {  26,-376 },
 {  27,-376 }, {  28,-376 }, {  29,-376 }, {  30,-376 }, {  31,-376 },
 {  32,-376 }, {  33,-376 }, {  34,-376 }, {  35,-376 }, {  36,-376 },
 {  37,-376 }, {  38,-376 }, {  39,-376 }, {  40,-376 }, {  41,-376 },
 {  42,-376 }, {  43,-376 }, {  44,-376 }, {  45,-376 }, {  46,-376 },

 {  47,-376 }, {  48,-376 }, {  49,-376 }, {  50,-376 }, {  51,-376 },
 {  52,-376 }, {  53,-376 }, {  54,-376 }, {  55,-376 }, {  56,-376 },
 {  57,-376 }, {  58,-376 }, {  59,-376 }, {  60,-376 }, {  61,-376 },
 {  62,-376 }, {  63,-376 }, {  64,-376 }, {  65,-376 }, {  66,-376 },
 {  67,-376 }, {  68,-376 }, {  69,-376 }, {  70,-376 }, {  71,-376 },
 {  72,-376 }, {  73,-376 }, {  74,-376 }, {  75,-376 }, {  76,-376 },
 {  77,-376 }, {  78,-376 }, {  79,-376 }, {  80,-376 }, {  81,-376 },
 {  82,-376 }, {  83,-376 }, {  84,-376 }, {  85,-376 }, {  86,-376 },
 {  87,-376 }, {  88,-376 }, {  89,-376 }, {  90,-376 }, {  91,-376 },
 {  92,-376 }, {  93,-376 }, {  94,-376 }, {  95,-376 }, {  96,-376 },

 {  97,-376 }, {  98,-376 }, {  99,-376 }, { 100,-376 }, { 101,-376 },
 { 102,-376 }, { 103,-376 }, { 104,-376 }, { 105,-376 }, { 106,-376 },
 { 107,-376 }, { 108,-376 }, { 109,-376 }, { 110,-376 }, { 111,-376 },
 { 112,-376 }, { 113,-376 }, { 114,-376 }, { 115,-376 }, { 116,-376 },
 { 117,-376 }, { 118,-376 }, { 119,-376 }, { 120,-376 }, { 121,-376 },
 { 122,-376 }, { 123,-376 }, { 124,-376 }, { 125,-376 }, { 126,-376 },
 { 127,-376 }, { 128,-376 }, { 129,-376 }, { 130,-376 }, { 131,-376 },
 { 132,-376 }, { 133,-376 }, { 134,-376 }, { 135,-376 }, { 136,-376 },
 { 137,-376 }, { 138,-376 }, { 139,-376 }, { 140,-376 }, { 141,-376 },
 { 142,-376 }, { 143,-376 }, { 144,-376 }, { 145,-376 }, { 146,-376 },

 { 147,-376 }, { 148,-376 }, { 149,-376 }, { 150,-376 }, { 151,-376 },
 { 152,-376 }, { 153,-376 }, { 154,-376 }, { 155,-376 }, { 156,-376 },
 { 157,-376 }, { 158,-376 }, { 159,-376 }, { 160,-376 }, { 161,-376 },
 { 162,-376 }, { 163,-376 }, { 164,-376 }, { 165,-376 }, { 166,-376 },
 { 167,-376 }, { 168,-376 }, { 169,-376 }, { 170,-376 }, { 171,-376 },
 { 172,-376 }, { 173,-376 }, { 174,-376 }, { 175,-376 }, { 176,-376 },
 { 177,-376 }, { 178,-376 }, { 179,-376 }, { 180,-376 }, { 181,-376 },
 { 182,-376 }, { 183,-376 }, { 184,-376 }, { 185,-376 }, { 186,-376 },
 { 187,-376 }, { 188,-376 }, { 189,-376 }, { 190,-376 }, { 191,-376 },
 { 192,-376 }, { 193,-376 }, { 194,-376 }, { 195,-376 }, { 196,-376 },

 { 197,-376 }, { 198,-376 }, { 199,-376 }, { 200,-376 }, { 201,-376 },
 { 202,-376 }, { 203,-376 }, { 204,-376 }, { 205,-376 }, { 206,-376 },
 { 207,-376 }, { 208,-376 }, { 209,-376 }, { 210,-376 }, { 211,-376 },
 { 212,-376 }, { 213,-376 }, { 214,-376 }, { 215,-376 }, { 216,-376 },
 { 217,-376 }, { 218,-376 }, { 219,-376 }, { 220,-376 }, { 221,-376 },
 { 222,-376 }, { 223,-376 }, { 224,-376 }, { 225,-376 }, { 226,-376 },
 { 227,-376 }, { 228,-376 }, { 229,-376 }, { 230,-376 }, { 231,-376 },
 { 232,-376 }, { 233,-376 }, { 234,-376 }, { 235,-376 }, { 236,-376 },
 { 237,-376 }, { 238,-376 }, { 239,-376 }, { 240,-376 }, { 241,-376 },
 { 242,-376 }, { 243,-376 }, { 244,-376 }, { 245,-376 }, { 246,-376 },

 { 247,-376 }, { 248,-376 }, { 249,-376 }, { 250,-376 }, { 251,-376 },
 { 252,-376 }, { 253,-376 }, { 254,-376 }, { 255,-376 }, { 256,-376 },
 {   0,  52 }, {   0, 516 }, {   1,-634 }, {   2,-634 }, {   3,-634 },
 {   4,-634 }, {   5,-634 }, {   6,-634 }, {   7,-634 }, {   8,-634 },
 {   9,-634 }, {  10,-750 }, {  11,-634 }, {  12,-634 }, {  13,-634 },
 {  14,-634 }, {  15,-634 }, {  16,-634 }, {  17,-634 }, {  18,-634 },
 {  19,-634 }, {  20,-634 }, {  21,-634 }, {  22,-634 }, {  23,-634 },
 {  24,-634 }, {  25,-634 }, {  26,-634 }, {  27,-634 }, {  28,-634 },
 {  29,-634 }, {  30,-634 }, {  31,-634 }, {  32,-634 }, {  33,-634 },
 {  34,-634 }, {  35,-634 }, {  36,-634 }, {  37,-634 }, {  38,-634 },

 {  39,-634 }, {  40,-634 }, {  41,-634 }, {  42,-634 }, {  43,-634 },
 {  44,-634 }, {  45,-634 }, {  46,-634 }, {  47,-634 }, {  48,-634 },
 {  49,-634 }, {  50,-634 }, {  51,-634 }, {  52,-634 }, {  53,-634 },
 {  54,-634 }, {  55,-634 }, {  56,-634 }, {  57,-634 }, {  58,-634 },
 {  59,-634 }, {  60,-634 }, {  61,-634 }, {  62,-634 }, {  63,-634 },
 {  64,-634 }, {  65,-634 }, {  66,-634 }, {  67,-634 }, {  68,-634 },
 {  69,-634 }, {  70,-634 }, {  71,-634 }, {  72,-634 }, {  73,-634 },
 {  74,-634 }, {  75,-634 }, {  76,-634 }, {  77,-634 }, {  78,-634 },
 {  79,-634 }, {  80,-634 }, {  81,-634 }, {  82,-634 }, {  83,-634 },
 {  84,-634 }, {  85,-634 }, {  86,-634 }, {  87,-634 }, {  88,-634 },

 {  89,-634 }, {  90,-634 }, {  91,-634 }, {  92,-634 }, {  93,-634 },
 {  94,-634 }, {  95,-634 }, {  96,-634 }, {  97,-634 }, {  98,-634 },
 {  99,-634 }, { 100,-634 }, { 101,-634 }, { 102,-634 }, { 103,-634 },
 { 104,-634 }, { 105,-634 }, { 106,-634 }, { 107,-634 }, { 108,-634 },
 { 109,-634 }, { 110,-634 }, { 111,-634 }, { 112,-634 }, { 113,-634 },
 { 114,-634 }, { 115,-634 }, { 116,-634 }, { 117,-634 }, { 118,-634 },
 { 119,-634 }, { 120,-634 }, { 121,-634 }, { 122,-634 }, { 123,-634 },
 { 124,-634 }, { 125,-634 }, { 126,-634 }, { 127,-634 }, { 128,-634 },
 { 129,-634 }, { 130,-634 }, { 131,-634 }, { 132,-634 }, { 133,-634 },
 { 134,-634 }, { 135,-634 }, { 136,-634 }, { 137,-634 }, { 138,-634 },

 { 139,-634 }, { 140,-634 }, { 141,-634 }, { 142,-634 }, { 143,-634 },
 { 144,-634 }, { 145,-634 }, { 146,-634 }, { 147,-634 }, { 148,-634 },
 { 149,-634 }, { 150,-634 }, { 151,-634 }, { 152,-634 }, { 153,-634 },
 { 154,-634 }, { 155,-634 }, { 156,-634 }, { 157,-634 }, { 158,-634 },
 { 159,-634 }, { 160,-634 }, { 161,-634 }, { 162,-634 }, { 163,-634 },
 { 164,-634 }, { 165,-634 }, { 166,-634 }, { 167,-634 }, { 168,-634 },
 { 169,-634 }, { 170,-634 }, { 171,-634 }, { 172,-634 }, { 173,-634 },
 { 174,-634 }, { 175,-634 }, { 176,-634 }, { 177,-634 }, { 178,-634 },
 { 179,-634 }, { 180,-634 }, { 181,-634 }, { 182,-634 }, { 183,-634 },
 { 184,-634 }, { 185,-634 }, { 186,-634 }, { 187,-634 }, { 188,-634 },

 { 189,-634 }, { 190,-634 }, { 191,-634 }, { 192,-634 }, { 193,-634 },
 { 194,-634 }, { 195,-634 }, { 196,-634 }, { 197,-634 }, { 198,-634 },
 { 199,-634 }, { 200,-634 }, { 201,-634 }, { 202,-634 }, { 203,-634 },
 { 204,-634 }, { 205,-634 }, { 206,-634 }, { 207,-634 }, { 208,-634 },
 { 209,-634 }, { 210,-634 }, { 211,-634 }, { 212,-634 }, { 213,-634 },
 { 214,-634 }, { 215,-634 }, { 216,-634 }, { 217,-634 }, { 218,-634 },
 { 219,-634 }, { 220,-634 }, { 221,-634 }, { 222,-634 }, { 223,-634 },
 { 224,-634 }, { 225,-634 }, { 226,-634 }, { 227,-634 }, { 228,-634 },
 { 229,-634 }, { 230,-634 }, { 231,-634 }, { 232,-634 }, { 233,-634 },
 { 234,-634 }, { 235,-634 }, { 236,-634 }, { 237,-634 }, { 238,-634 },

 { 239,-634 }, { 240,-634 }, { 241,-634 }, { 242,-634 }, { 243,-634 },
 { 244,-634 }, { 245,-634 }, { 246,-634 }, { 247,-634 }, { 248,-634 },
 { 249,-634 }, { 250,-634 }, { 251,-634 }, { 252,-634 }, { 253,-634 },
 { 254,-634 }, { 255,-634 }, { 256,-634 }, {   0,  52 }, {   0, 258 },
 {   1,-892 }, {   2,-892 }, {   3,-892 }, {   4,-892 }, {   5,-892 },
 {   6,-892 }, {   7,-892 }, {   8,-892 }, {   9,-892 }, {  10,-1008 },
 {  11,-892 }, {  12,-892 }, {  13,-892 }, {  14,-892 }, {  15,-892 },
 {  16,-892 }, {  17,-892 }, {  18,-892 }, {  19,-892 }, {  20,-892 },
 {  21,-892 }, {  22,-892 }, {  23,-892 }, {  24,-892 }, {  25,-892 },
 {  26,-892 }, {  27,-892 }, {  28,-892 }, {  29,-892 }, {  30,-892 },

 {  31,-892 }, {  32,-892 }, {  33,-892 }, {  34,-892 }, {  35,-892 },
 {  36,-892 }, {  37,-892 }, {  38,-892 }, {  39,-892 }, {  40,-892 },
 {  41,-892 }, {  42,-892 }, {  43,-892 }, {  44,-892 }, {  45,-892 },
 {  46,-892 }, {  47,-892 }, {  48,-892 }, {  49,-892 }, {  50,-892 },
 {  51,-892 }, {  52,-892 }, {  53,-892 }, {  54,-892 }, {  55,-892 },
 {  56,-892 }, {  57,-892 }, {  58,-892 }, {  59,-892 }, {  60,-892 },
 {  61,-892 }, {  62,-892 }, {  63,-892 }, {  64,-892 }, {  65,-892 },
 {  66,-892 }, {  67,-892 }, {  68,-892 }, {  69,-892 }, {  70,-892 },
 {  71,-892 }, {  72,-892 }, {  73,-892 }, {  74,-892 }, {  75,-892 },
 {  76,-892 }, {  77,-892 }, {  78,-892 }, {  79,-892 }, {  80,-892 },

 {  81,-892 }, {  82,-892 }, {  83,-892 }, {  84,-892 }, {  85,-892 },
 {  86,-892 }, {  87,-892 }, {  88,-892 }, {  89,-892 }, {  90,-892 },
 {  91,-892 }, {  92,-892 }, {  93,-892 }, {  94,-892 }, {  95,-892 },
 {  96,-892 }, {  97,-892 }, {  98,-892 }, {  99,-892 }, { 100,-892 },
 { 101,-892 }, { 102,-892 }, { 103,-892 }, { 104,-892 }, { 105,-892 },
 { 106,-892 }, { 107,-892 }, { 108,-892 }, { 109,-892 }, { 110,-892 },
 { 111,-892 }, { 112,-892 }, { 113,-892 }, { 114,-892 }, { 115,-892 },
 { 116,-892 }, { 117,-892 }, { 118,-892 }, { 119,-892 }, { 120,-892 },
 { 121,-892 }, { 122,-892 }, { 123,-892 }, { 124,-892 }, { 125,-892 },
 { 126,-892 }, { 127,-892 }, { 128,-892 }, { 129,-892 }, { 130,-892 },

 { 131,-892 }, { 132,-892 }, { 133,-892 }, { 134,-892 }, { 135,-892 },
 { 136,-892 }, { 137,-892 }, { 138,-892 }, { 139,-892 }, { 140,-892 },
 { 141,-892 }, { 142,-892 }, { 143,-892 }, { 144,-892 }, { 145,-892 },
 { 146,-892 }, { 147,-892 }, { 148,-892 }, { 149,-892 }, { 150,-892 },
 { 151,-892 }, { 152,-892 }, { 153,-892 }, { 154,-892 }, { 155,-892 },
 { 156,-892 }, { 157,-892 }, { 158,-892 }, { 159,-892 }, { 160,-892 },
 { 161,-892 }, { 162,-892 }, { 163,-892 }, { 164,-892 }, { 165,-892 },
 { 166,-892 }, { 167,-892 }, { 168,-892 }, { 169,-892 }, { 170,-892 },
 { 171,-892 }, { 172,-892 }, { 173,-892 }, { 174,-892 }, { 175,-892 },
 { 176,-892 }, { 177,-892 }, { 178,-892 }, { 179,-892 }, { 180,-892 },

 { 181,-892 }, { 182,-892 }, { 183,-892 }, { 184,-892 }, { 185,-892 },
 { 186,-892 }, { 187,-892 }, { 188,-892 }, { 189,-892 }, { 190,-892 },
 { 191,-892 }, { 192,-892 }, { 193,-892 }, { 194,-892 }, { 195,-892 },
 { 196,-892 }, { 197,-892 }, { 198,-892 }, { 199,-892 }, { 200,-892 },
 { 201,-892 }, { 202,-892 }, { 203,-892 }, { 204,-892 }, { 205,-892 },
 { 206,-892 }, { 207,-892 }, { 208,-892 }, { 209,-892 }, { 210,-892 },
 { 211,-892 }, { 212,-892 }, { 213,-892 }, { 214,-892 }, { 215,-892 },
 { 216,-892 }, { 217,-892 }, { 218,-892 }, { 219,-892 }, { 220,-892 },
 { 221,-892 }, { 222,-892 }, { 223,-892 }, { 224,-892 }, { 225,-892 },
 { 226,-892 }, { 227,-892 }, { 228,-892 }, { 229,-892 }, { 230,-892 },

 { 231,-892 }, { 232,-892 }, { 233,-892 }, { 234,-892 }, { 235,-892 },
 { 236,-892 }, { 237,-892 }, { 238,-892 }, { 239,-892 }, { 240,-892 },
 { 241,-892 }, { 242,-892 }, { 243,-892 }, { 244,-892 }, { 245,-892 },
 { 246,-892 }, { 247,-892 }, { 248,-892 }, { 249,-892 }, { 250,-892 },
 { 251,-892 }, { 252,-892 }, { 253,-892 }, { 254,-892 }, { 255,-892 },
 { 256,-892 }, { 257,  55 }, {   1,   0 },    };

static yyconst struct yy_trans_info *yy_start_state_list[5] =
    {
    &yy_transition[1],
    &yy_transition[3],
    &yy_transition[261],
    &yy_transition[519],
    &yy_transition[777],

    } ;

/* The intent behind this definition is that it'll catch
 * any uses of REJECT which flex missed.
 */
#define REJECT reject_used_but_not_detected
#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0
#define YY_RESTORE_YY_MORE_OFFSET
#line 1 "content_filter.l"

#line 38 "content_filter.l"
#include "src/util.h"
#include <ctype.h>
#define YY_NO_INPUT 1
#define YY_NO_INPUT 1
/* bison-locations stack read */ 

#line 1916 "src/src_liblistserv_la-content_filter.c"

#define INITIAL 0
#define ACTION 1

#ifndef YY_NO_UNISTD_H
/* Special case for "unistd.h", since it is non-ANSI. We include it way
 * down here because we want the user's section 1 to have been scanned first.
 * The user has a chance to override it with an option.
 */
#include <unistd.h>
#endif

#ifndef YY_EXTRA_TYPE
#define YY_EXTRA_TYPE void *
#endif

/* Holds the entire state of the reentrant scanner. */
struct yyguts_t
    {

    /* User-defined. Not touched by flex. */
    YY_EXTRA_TYPE yyextra_r;

    /* The rest are the same as the globals declared in the non-reentrant scanner. */
    FILE *yyin_r, *yyout_r;
    size_t yy_buffer_stack_top; /**< index of top of stack. */
    size_t yy_buffer_stack_max; /**< capacity of stack. */
    YY_BUFFER_STATE * yy_buffer_stack; /**< Stack as an array. */
    char yy_hold_char;
    int yy_n_chars;
    int yyleng_r;
    char *yy_c_buf_p;
    int yy_init;
    int yy_start;
    int yy_did_buffer_switch_on_eof;
    int yy_start_stack_ptr;
    int yy_start_stack_depth;
    int *yy_start_stack;
    yy_state_type yy_last_accepting_state;
    char* yy_last_accepting_cpos;

    int yylineno_r;
    int yy_flex_debug_r;

    char *yytext_r;
    int yy_more_flag;
    int yy_more_len;

    YYSTYPE * yylval_r;

    }; /* end struct yyguts_t */

static int yy_init_globals (yyscan_t yyscanner );

    /* This must go here because YYSTYPE and YYLTYPE are included
     * from bison output in section 1.*/
    #    define yylval yyg->yylval_r
    
int listserv_content_filterlex_init (yyscan_t* scanner);

int listserv_content_filterlex_init_extra (YY_EXTRA_TYPE user_defined,yyscan_t* scanner);

/* Accessor methods to globals.
   These are made visible to non-reentrant scanners for convenience. */

int listserv_content_filterlex_destroy (yyscan_t yyscanner );

YY_EXTRA_TYPE listserv_content_filterget_extra (yyscan_t yyscanner );

void listserv_content_filterset_extra (YY_EXTRA_TYPE user_defined ,yyscan_t yyscanner );

YYSTYPE * listserv_content_filterget_lval (yyscan_t yyscanner );

void listserv_content_filterset_lval (YYSTYPE * yylval_param ,yyscan_t yyscanner );

/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifndef YY_SKIP_YYWRAP
#ifdef __cplusplus
extern "C" int listserv_content_filterwrap (yyscan_t yyscanner );
#else
extern int listserv_content_filterwrap (yyscan_t yyscanner );
#endif
#endif

#ifndef yytext_ptr
static void yy_flex_strncpy (char *,yyconst char *,int ,yyscan_t yyscanner);
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (yyconst char * ,yyscan_t yyscanner);
#endif

#ifndef YY_NO_INPUT

#ifdef __cplusplus
static int yyinput (yyscan_t yyscanner );
#else
static int input (yyscan_t yyscanner );
#endif

#endif

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#define YY_READ_BUF_SIZE 8192
#endif

/* Copy whatever the last rule matched to the standard output. */
#ifndef ECHO
/* This used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite().
 */
#define ECHO fwrite( yytext, yyleng, 1, yyout )
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
	errno=0; \
	while ( (result = read( fileno(yyin), (char *) buf, max_size )) < 0 ) \
	{ \
		if( errno != EINTR) \
		{ \
			YY_FATAL_ERROR( "input in flex scanner failed" ); \
			break; \
		} \
		errno=0; \
		clearerr(yyin); \
	}\
\

#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
#define YY_FATAL_ERROR(msg) yy_fatal_error( msg , yyscanner)
#endif

/* end tables serialization structures and prototypes */

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL_IS_OURS 1

extern int listserv_content_filterlex \
               (YYSTYPE * yylval_param ,yyscan_t yyscanner);

#define YY_DECL int listserv_content_filterlex \
               (YYSTYPE * yylval_param , yyscan_t yyscanner)
#endif /* !YY_DECL */

/* Code executed at the beginning of each rule, after yytext and yyleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK break;
#endif

#define YY_RULE_SETUP \
	YY_USER_ACTION

/** The main scanner function which does all the work.
 */
YY_DECL
{
	register yy_state_type yy_current_state;
	register char *yy_cp, *yy_bp;
	register int yy_act;
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

#line 53 "content_filter.l"

#line 2114 "src/src_liblistserv_la-content_filter.c"

    yylval = yylval_param;

	if ( !yyg->yy_init )
		{
		yyg->yy_init = 1;

#ifdef YY_USER_INIT
		YY_USER_INIT;
#endif

		if ( ! yyg->yy_start )
			yyg->yy_start = 1;	/* first start state */

		if ( ! yyin )
			yyin = stdin;

		if ( ! yyout )
			yyout = stdout;

		if ( ! YY_CURRENT_BUFFER ) {
			listserv_content_filterensure_buffer_stack (yyscanner);
			YY_CURRENT_BUFFER_LVALUE =
				listserv_content_filter_create_buffer(yyin,YY_BUF_SIZE ,yyscanner);
		}

		listserv_content_filter_load_buffer_state(yyscanner );
		}

	while ( 1 )		/* loops until end-of-file is reached */
		{
		yy_cp = yyg->yy_c_buf_p;

		/* Support of yytext. */
		*yy_cp = yyg->yy_hold_char;

		/* yy_bp points to the position in yy_ch_buf of the start of
		 * the current run.
		 */
		yy_bp = yy_cp;

		yy_current_state = yy_start_state_list[yyg->yy_start];
yy_match:
		{
		register yyconst struct yy_trans_info *yy_trans_info;

		register YY_CHAR yy_c;

		for ( yy_c = YY_SC_TO_UI(*yy_cp);
		      (yy_trans_info = &yy_current_state[(unsigned int) yy_c])->
		yy_verify == yy_c;
		      yy_c = YY_SC_TO_UI(*++yy_cp) )
			yy_current_state += yy_trans_info->yy_nxt;
		}

yy_find_action:
		yy_act = yy_current_state[-1].yy_nxt;

		YY_DO_BEFORE_ACTION;

do_action:	/* This label is used only to access EOF actions. */

		switch ( yy_act )
	{ /* beginning of action switch */
case YY_STATE_EOF(INITIAL):
#line 54 "content_filter.l"
yyterminate ();
	YY_BREAK
case 1:
#line 57 "content_filter.l"
case 2:
/* rule 2 can match eol */
#line 58 "content_filter.l"
case 3:
/* rule 3 can match eol */
#line 59 "content_filter.l"
case 4:
/* rule 4 can match eol */
YY_RULE_SETUP
#line 59 "content_filter.l"
{
            BEGIN (ACTION);
            YYSTYPE val = *listserv_content_filterget_lval (yyscanner);
            char *a = strchr (yytext, ':');
            a[0] = '\0';
            val[0] = strdup (yytext); /* header-field */
            a+=2;
            if (yytext[yyleng - 1] == '\n')
              yytext[yyleng - 1] = '\0';
            int strlen_a = strlen (a);
            val[1] = malloc (strlen_a + 3); /* header-value */
            val[1][0] = '*';
            strcpy (val[1]+1, a);
            val[1][strlen_a+1] = '*';
            val[1][strlen_a+2] = '\0';
        }
	YY_BREAK
case 5:
#line 77 "content_filter.l"
case 6:
/* rule 6 can match eol */
#line 78 "content_filter.l"
case 7:
/* rule 7 can match eol */
#line 79 "content_filter.l"
case 8:
/* rule 8 can match eol */
#line 80 "content_filter.l"
case 9:
/* rule 9 can match eol */
#line 81 "content_filter.l"
case 10:
/* rule 10 can match eol */
#line 82 "content_filter.l"
case 11:
/* rule 11 can match eol */
#line 83 "content_filter.l"
case 12:
/* rule 12 can match eol */
#line 84 "content_filter.l"
case 13:
/* rule 13 can match eol */
YY_RULE_SETUP
#line 84 "content_filter.l"
{
            BEGIN (ACTION);
            YYSTYPE ret = *listserv_content_filterget_lval (yyscanner);
            ret[0] = strdup ("Text");
            if (yytext[yyleng - 1] == '\n')
               yytext[yyleng -1] = '\0';
            ret[1] = strdup (yytext);
        }
	YY_BREAK
case 14:
#line 95 "content_filter.l"
case 15:
/* rule 15 can match eol */
#line 96 "content_filter.l"
case 16:
/* rule 16 can match eol */
#line 97 "content_filter.l"
case 17:
/* rule 17 can match eol */
YY_RULE_SETUP
#line 97 "content_filter.l"
{ /* exact-match -- empty/no header */
            BEGIN (ACTION);
            YYSTYPE val = *listserv_content_filterget_lval (yyscanner);
            char *a = strchr (yytext, ':');
            a[0] = '\0';
            val[0] = strdup (yytext);
            val[1] = strdup ("");
        }
	YY_BREAK
case 18:
#line 107 "content_filter.l"
case 19:
/* rule 19 can match eol */
YY_RULE_SETUP
#line 107 "content_filter.l"
{
            BEGIN(ACTION);
            YYSTYPE val = *listserv_content_filterget_lval (yyscanner);
            char *a = strchr(yytext, ':');
            a[0] = '\0';
            val[0] = strdup (yytext); /* header-field */
            if (yytext[yyleng - 1] == '\n')
              yytext[yyleng - 1] = '\0';
            val[1] = strdup (a+3); /* header-value */
        }
	YY_BREAK
case 20:
/* rule 20 can match eol */
YY_RULE_SETUP
#line 118 "content_filter.l"

	YY_BREAK
case 21:
#line 121 "content_filter.l"
case 22:
#line 122 "content_filter.l"
case 23:
#line 123 "content_filter.l"
case 24:
#line 124 "content_filter.l"
case 25:
#line 125 "content_filter.l"
case 26:
#line 126 "content_filter.l"
case 27:
#line 127 "content_filter.l"
case 28:
#line 128 "content_filter.l"
case 29:
#line 129 "content_filter.l"
case 30:
#line 130 "content_filter.l"
case 31:
#line 131 "content_filter.l"
case 32:
#line 132 "content_filter.l"
case 33:
#line 133 "content_filter.l"
case 34:
#line 134 "content_filter.l"
case 35:
#line 135 "content_filter.l"
case 36:
#line 136 "content_filter.l"
case 37:
#line 137 "content_filter.l"
case 38:
#line 138 "content_filter.l"
case 39:
#line 139 "content_filter.l"
case 40:
/* rule 40 can match eol */
#line 140 "content_filter.l"
case 41:
/* rule 41 can match eol */
#line 141 "content_filter.l"
case 42:
/* rule 42 can match eol */
#line 142 "content_filter.l"
case 43:
/* rule 43 can match eol */
#line 143 "content_filter.l"
case 44:
/* rule 44 can match eol */
#line 144 "content_filter.l"
case 45:
/* rule 45 can match eol */
#line 145 "content_filter.l"
case 46:
/* rule 46 can match eol */
#line 146 "content_filter.l"
case 47:
/* rule 47 can match eol */
#line 147 "content_filter.l"
case 48:
/* rule 48 can match eol */
#line 148 "content_filter.l"
case 49:
/* rule 49 can match eol */
#line 149 "content_filter.l"
case 50:
/* rule 50 can match eol */
#line 150 "content_filter.l"
case YY_STATE_EOF(ACTION):
#line 150 "content_filter.l"
case 51:
/* rule 51 can match eol */
YY_RULE_SETUP
#line 151 "content_filter.l"
{
            BEGIN (INITIAL);
            YYSTYPE val = *listserv_content_filterget_lval (yyscanner);
            val[2] = NULL;
            if (yytext[0] != '\0')
              yyless(0);
            return ACTION_REJECT;
         }
	YY_BREAK
case 52:
#line 161 "content_filter.l"
case 53:
/* rule 53 can match eol */
YY_RULE_SETUP
#line 161 "content_filter.l"
{
            BEGIN (INITIAL);
            YYSTYPE val = *listserv_content_filterget_lval (yyscanner);
            if (yytext[yyleng -1] == '\n') 
                yytext[yyleng -1] = '\0';
            char *a = strchr (yytext+9, ' ');
            val[2] = (a && a+1) ? strdup (a+1) : NULL;
            switch (tolower (yytext[8])) {
                case 'a': return ACTION_ALLOW;
                case 'r': return ACTION_REJECT;
                case 'm': return ACTION_MODERATE;
                case 'd': return ACTION_DISCARD;
                default : return 0;
            }
        }
	YY_BREAK
case 54:
YY_RULE_SETUP
#line 176 "content_filter.l"
YY_FATAL_ERROR( "flex scanner jammed" );
	YY_BREAK
#line 2405 "src/src_liblistserv_la-content_filter.c"

	case YY_END_OF_BUFFER:
		{
		/* Amount of text matched not including the EOB char. */
		int yy_amount_of_matched_text = (int) (yy_cp - yyg->yytext_ptr) - 1;

		/* Undo the effects of YY_DO_BEFORE_ACTION. */
		*yy_cp = yyg->yy_hold_char;
		YY_RESTORE_YY_MORE_OFFSET

		if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_NEW )
			{
			/* We're scanning a new file or input source.  It's
			 * possible that this happened because the user
			 * just pointed yyin at a new source and called
			 * listserv_content_filterlex().  If so, then we have to assure
			 * consistency between YY_CURRENT_BUFFER and our
			 * globals.  Here is the right place to do so, because
			 * this is the first action (other than possibly a
			 * back-up) that will match for the new input source.
			 */
			yyg->yy_n_chars = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
			YY_CURRENT_BUFFER_LVALUE->yy_input_file = yyin;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status = YY_BUFFER_NORMAL;
			}

		/* Note that here we test for yy_c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since yy_c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the
		 * end-of-buffer state).  Contrast this with the test
		 * in input().
		 */
		if ( yyg->yy_c_buf_p <= &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[yyg->yy_n_chars] )
			{ /* This was really a NUL. */
			yy_state_type yy_next_state;

			yyg->yy_c_buf_p = yyg->yytext_ptr + yy_amount_of_matched_text;

			yy_current_state = yy_get_previous_state( yyscanner );

			/* Okay, we're now positioned to make the NUL
			 * transition.  We couldn't have
			 * yy_get_previous_state() go ahead and do it
			 * for us because it doesn't know how to deal
			 * with the possibility of jamming (and we don't
			 * want to build jamming into it because then it
			 * will run more slowly).
			 */

			yy_next_state = yy_try_NUL_trans( yy_current_state , yyscanner);

			yy_bp = yyg->yytext_ptr + YY_MORE_ADJ;

			if ( yy_next_state )
				{
				/* Consume the NUL. */
				yy_cp = ++yyg->yy_c_buf_p;
				yy_current_state = yy_next_state;
				goto yy_match;
				}

			else
				{
				yy_cp = yyg->yy_c_buf_p;
				goto yy_find_action;
				}
			}

		else switch ( yy_get_next_buffer( yyscanner ) )
			{
			case EOB_ACT_END_OF_FILE:
				{
				yyg->yy_did_buffer_switch_on_eof = 0;

				if ( listserv_content_filterwrap(yyscanner ) )
					{
					/* Note: because we've taken care in
					 * yy_get_next_buffer() to have set up
					 * yytext, we can now set up
					 * yy_c_buf_p so that if some total
					 * hoser (like flex itself) wants to
					 * call the scanner after we return the
					 * YY_NULL, it'll still work - another
					 * YY_NULL will get returned.
					 */
					yyg->yy_c_buf_p = yyg->yytext_ptr + YY_MORE_ADJ;

					yy_act = YY_STATE_EOF(YY_START);
					goto do_action;
					}

				else
					{
					if ( ! yyg->yy_did_buffer_switch_on_eof )
						YY_NEW_FILE;
					}
				break;
				}

			case EOB_ACT_CONTINUE_SCAN:
				yyg->yy_c_buf_p =
					yyg->yytext_ptr + yy_amount_of_matched_text;

				yy_current_state = yy_get_previous_state( yyscanner );

				yy_cp = yyg->yy_c_buf_p;
				yy_bp = yyg->yytext_ptr + YY_MORE_ADJ;
				goto yy_match;

			case EOB_ACT_LAST_MATCH:
				yyg->yy_c_buf_p =
				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[yyg->yy_n_chars];

				yy_current_state = yy_get_previous_state( yyscanner );

				yy_cp = yyg->yy_c_buf_p;
				yy_bp = yyg->yytext_ptr + YY_MORE_ADJ;
				goto yy_find_action;
			}
		break;
		}

	default:
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
} /* end of listserv_content_filterlex */

/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */
static int yy_get_next_buffer (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
	register char *dest = YY_CURRENT_BUFFER_LVALUE->yy_ch_buf;
	register char *source = yyg->yytext_ptr;
	register int number_to_move, i;
	int ret_val;

	if ( yyg->yy_c_buf_p > &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[yyg->yy_n_chars + 1] )
		YY_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

	if ( YY_CURRENT_BUFFER_LVALUE->yy_fill_buffer == 0 )
		{ /* Don't try to fill the buffer, so this is an EOF. */
		if ( yyg->yy_c_buf_p - yyg->yytext_ptr - YY_MORE_ADJ == 1 )
			{
			/* We matched a single character, the EOB, so
			 * treat this as a final EOF.
			 */
			return EOB_ACT_END_OF_FILE;
			}

		else
			{
			/* We matched some text prior to the EOB, first
			 * process it.
			 */
			return EOB_ACT_LAST_MATCH;
			}
		}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = (int) (yyg->yy_c_buf_p - yyg->yytext_ptr) - 1;

	for ( i = 0; i < number_to_move; ++i )
		*(dest++) = *(source++);

	if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_EOF_PENDING )
		/* don't do the read, it's not guaranteed to return an EOF,
		 * just force an EOF
		 */
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = yyg->yy_n_chars = 0;

	else
		{
			int num_to_read =
			YY_CURRENT_BUFFER_LVALUE->yy_buf_size - number_to_move - 1;

		while ( num_to_read <= 0 )
			{ /* Not enough room in the buffer - grow it. */

			/* just a shorter name for the current buffer */
			YY_BUFFER_STATE b = YY_CURRENT_BUFFER;

			int yy_c_buf_p_offset =
				(int) (yyg->yy_c_buf_p - b->yy_ch_buf);

			if ( b->yy_is_our_buffer )
				{
				int new_size = b->yy_buf_size * 2;

				if ( new_size <= 0 )
					b->yy_buf_size += b->yy_buf_size / 8;
				else
					b->yy_buf_size *= 2;

				b->yy_ch_buf = (char *)
					/* Include room in for 2 EOB chars. */
					listserv_content_filterrealloc((void *) b->yy_ch_buf,b->yy_buf_size + 2 ,yyscanner );
				}
			else
				/* Can't grow it, we don't own it. */
				b->yy_ch_buf = 0;

			if ( ! b->yy_ch_buf )
				YY_FATAL_ERROR(
				"fatal error - scanner input buffer overflow" );

			yyg->yy_c_buf_p = &b->yy_ch_buf[yy_c_buf_p_offset];

			num_to_read = YY_CURRENT_BUFFER_LVALUE->yy_buf_size -
						number_to_move - 1;

			}

		if ( num_to_read > YY_READ_BUF_SIZE )
			num_to_read = YY_READ_BUF_SIZE;

		/* Read in more data. */
		YY_INPUT( (&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move]),
			yyg->yy_n_chars, (size_t) num_to_read );

		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = yyg->yy_n_chars;
		}

	if ( yyg->yy_n_chars == 0 )
		{
		if ( number_to_move == YY_MORE_ADJ )
			{
			ret_val = EOB_ACT_END_OF_FILE;
			listserv_content_filterrestart(yyin  ,yyscanner);
			}

		else
			{
			ret_val = EOB_ACT_LAST_MATCH;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status =
				YY_BUFFER_EOF_PENDING;
			}
		}

	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	if ((yy_size_t) (yyg->yy_n_chars + number_to_move) > YY_CURRENT_BUFFER_LVALUE->yy_buf_size) {
		/* Extend the array by 50%, plus the number we really need. */
		yy_size_t new_size = yyg->yy_n_chars + number_to_move + (yyg->yy_n_chars >> 1);
		YY_CURRENT_BUFFER_LVALUE->yy_ch_buf = (char *) listserv_content_filterrealloc((void *) YY_CURRENT_BUFFER_LVALUE->yy_ch_buf,new_size ,yyscanner );
		if ( ! YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )
			YY_FATAL_ERROR( "out of dynamic memory in yy_get_next_buffer()" );
	}

	yyg->yy_n_chars += number_to_move;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[yyg->yy_n_chars] = YY_END_OF_BUFFER_CHAR;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[yyg->yy_n_chars + 1] = YY_END_OF_BUFFER_CHAR;

	yyg->yytext_ptr = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[0];

	return ret_val;
}

/* yy_get_previous_state - get the state just before the EOB char was reached */

    static yy_state_type yy_get_previous_state (yyscan_t yyscanner)
{
	register yy_state_type yy_current_state;
	register char *yy_cp;
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

	yy_current_state = yy_start_state_list[yyg->yy_start];

	for ( yy_cp = yyg->yytext_ptr + YY_MORE_ADJ; yy_cp < yyg->yy_c_buf_p; ++yy_cp )
		{
		yy_current_state += yy_current_state[(*yy_cp ? YY_SC_TO_UI(*yy_cp) : 256)].yy_nxt;
		}

	return yy_current_state;
}

/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */
    static yy_state_type yy_try_NUL_trans  (yy_state_type yy_current_state , yyscan_t yyscanner)
{
	register int yy_is_jam;
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner; /* This var may be unused depending upon options. */

	register int yy_c = 256;
	register yyconst struct yy_trans_info *yy_trans_info;

	yy_trans_info = &yy_current_state[(unsigned int) yy_c];
	yy_current_state += yy_trans_info->yy_nxt;
	yy_is_jam = (yy_trans_info->yy_verify != yy_c);

	return yy_is_jam ? 0 : yy_current_state;
}

#ifndef YY_NO_INPUT
#ifdef __cplusplus
    static int yyinput (yyscan_t yyscanner)
#else
    static int input  (yyscan_t yyscanner)
#endif

{
	int c;
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

	*yyg->yy_c_buf_p = yyg->yy_hold_char;

	if ( *yyg->yy_c_buf_p == YY_END_OF_BUFFER_CHAR )
		{
		/* yy_c_buf_p now points to the character we want to return.
		 * If this occurs *before* the EOB characters, then it's a
		 * valid NUL; if not, then we've hit the end of the buffer.
		 */
		if ( yyg->yy_c_buf_p < &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[yyg->yy_n_chars] )
			/* This was really a NUL. */
			*yyg->yy_c_buf_p = '\0';

		else
			{ /* need more input */
			int offset = yyg->yy_c_buf_p - yyg->yytext_ptr;
			++yyg->yy_c_buf_p;

			switch ( yy_get_next_buffer( yyscanner ) )
				{
				case EOB_ACT_LAST_MATCH:
					/* This happens because yy_g_n_b()
					 * sees that we've accumulated a
					 * token and flags that we need to
					 * try matching the token before
					 * proceeding.  But for input(),
					 * there's no matching to consider.
					 * So convert the EOB_ACT_LAST_MATCH
					 * to EOB_ACT_END_OF_FILE.
					 */

					/* Reset buffer status. */
					listserv_content_filterrestart(yyin ,yyscanner);

					/*FALLTHROUGH*/

				case EOB_ACT_END_OF_FILE:
					{
					if ( listserv_content_filterwrap(yyscanner ) )
						return EOF;

					if ( ! yyg->yy_did_buffer_switch_on_eof )
						YY_NEW_FILE;
#ifdef __cplusplus
					return yyinput(yyscanner);
#else
					return input(yyscanner);
#endif
					}

				case EOB_ACT_CONTINUE_SCAN:
					yyg->yy_c_buf_p = yyg->yytext_ptr + offset;
					break;
				}
			}
		}

	c = *(unsigned char *) yyg->yy_c_buf_p;	/* cast for 8-bit char's */
	*yyg->yy_c_buf_p = '\0';	/* preserve yytext */
	yyg->yy_hold_char = *++yyg->yy_c_buf_p;

	return c;
}
#endif	/* ifndef YY_NO_INPUT */

/** Immediately switch to a different input stream.
 * @param input_file A readable stream.
 * @param yyscanner The scanner object.
 * @note This function does not reset the start condition to @c INITIAL .
 */
    void listserv_content_filterrestart  (FILE * input_file , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

	if ( ! YY_CURRENT_BUFFER ){
        listserv_content_filterensure_buffer_stack (yyscanner);
		YY_CURRENT_BUFFER_LVALUE =
            listserv_content_filter_create_buffer(yyin,YY_BUF_SIZE ,yyscanner);
	}

	listserv_content_filter_init_buffer(YY_CURRENT_BUFFER,input_file ,yyscanner);
	listserv_content_filter_load_buffer_state(yyscanner );
}

/** Switch to a different input buffer.
 * @param new_buffer The new input buffer.
 * @param yyscanner The scanner object.
 */
    void listserv_content_filter_switch_to_buffer  (YY_BUFFER_STATE  new_buffer , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

	/* TODO. We should be able to replace this entire function body
	 * with
	 *		listserv_content_filterpop_buffer_state();
	 *		listserv_content_filterpush_buffer_state(new_buffer);
     */
	listserv_content_filterensure_buffer_stack (yyscanner);
	if ( YY_CURRENT_BUFFER == new_buffer )
		return;

	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*yyg->yy_c_buf_p = yyg->yy_hold_char;
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = yyg->yy_c_buf_p;
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = yyg->yy_n_chars;
		}

	YY_CURRENT_BUFFER_LVALUE = new_buffer;
	listserv_content_filter_load_buffer_state(yyscanner );

	/* We don't actually know whether we did this switch during
	 * EOF (listserv_content_filterwrap()) processing, but the only time this flag
	 * is looked at is after listserv_content_filterwrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	yyg->yy_did_buffer_switch_on_eof = 1;
}

static void listserv_content_filter_load_buffer_state  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
	yyg->yy_n_chars = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
	yyg->yytext_ptr = yyg->yy_c_buf_p = YY_CURRENT_BUFFER_LVALUE->yy_buf_pos;
	yyin = YY_CURRENT_BUFFER_LVALUE->yy_input_file;
	yyg->yy_hold_char = *yyg->yy_c_buf_p;
}

/** Allocate and initialize an input buffer state.
 * @param file A readable stream.
 * @param size The character buffer size in bytes. When in doubt, use @c YY_BUF_SIZE.
 * @param yyscanner The scanner object.
 * @return the allocated buffer state.
 */
    YY_BUFFER_STATE listserv_content_filter_create_buffer  (FILE * file, int  size , yyscan_t yyscanner)
{
	YY_BUFFER_STATE b;
    
	b = (YY_BUFFER_STATE) listserv_content_filteralloc(sizeof( struct yy_buffer_state ) ,yyscanner );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in listserv_content_filter_create_buffer()" );

	b->yy_buf_size = size;

	/* yy_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->yy_ch_buf = (char *) listserv_content_filteralloc(b->yy_buf_size + 2 ,yyscanner );
	if ( ! b->yy_ch_buf )
		YY_FATAL_ERROR( "out of dynamic memory in listserv_content_filter_create_buffer()" );

	b->yy_is_our_buffer = 1;

	listserv_content_filter_init_buffer(b,file ,yyscanner);

	return b;
}

/** Destroy the buffer.
 * @param b a buffer created with listserv_content_filter_create_buffer()
 * @param yyscanner The scanner object.
 */
    void listserv_content_filter_delete_buffer (YY_BUFFER_STATE  b , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

	if ( ! b )
		return;

	if ( b == YY_CURRENT_BUFFER ) /* Not sure if we should pop here. */
		YY_CURRENT_BUFFER_LVALUE = (YY_BUFFER_STATE) 0;

	if ( b->yy_is_our_buffer )
		listserv_content_filterfree((void *) b->yy_ch_buf ,yyscanner );

	listserv_content_filterfree((void *) b ,yyscanner );
}

#ifndef __cplusplus
extern int isatty (int );
#endif /* __cplusplus */
    
/* Initializes or reinitializes a buffer.
 * This function is sometimes called more than once on the same buffer,
 * such as during a listserv_content_filterrestart() or at EOF.
 */
    static void listserv_content_filter_init_buffer  (YY_BUFFER_STATE  b, FILE * file , yyscan_t yyscanner)

{
	int oerrno = errno;
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

	listserv_content_filter_flush_buffer(b ,yyscanner);

	b->yy_input_file = file;
	b->yy_fill_buffer = 1;

    /* If b is the current buffer, then listserv_content_filter_init_buffer was _probably_
     * called from listserv_content_filterrestart() or through yy_get_next_buffer.
     * In that case, we don't want to reset the lineno or column.
     */
    if (b != YY_CURRENT_BUFFER){
        b->yy_bs_lineno = 1;
        b->yy_bs_column = 0;
    }

        b->yy_is_interactive = file ? (isatty( fileno(file) ) > 0) : 0;
    
	errno = oerrno;
}

/** Discard all buffered characters. On the next scan, YY_INPUT will be called.
 * @param b the buffer state to be flushed, usually @c YY_CURRENT_BUFFER.
 * @param yyscanner The scanner object.
 */
    void listserv_content_filter_flush_buffer (YY_BUFFER_STATE  b , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
	if ( ! b )
		return;

	b->yy_n_chars = 0;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

	b->yy_buf_pos = &b->yy_ch_buf[0];

	b->yy_at_bol = 1;
	b->yy_buffer_status = YY_BUFFER_NEW;

	if ( b == YY_CURRENT_BUFFER )
		listserv_content_filter_load_buffer_state(yyscanner );
}

/** Pushes the new state onto the stack. The new state becomes
 *  the current state. This function will allocate the stack
 *  if necessary.
 *  @param new_buffer The new state.
 *  @param yyscanner The scanner object.
 */
void listserv_content_filterpush_buffer_state (YY_BUFFER_STATE new_buffer , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
	if (new_buffer == NULL)
		return;

	listserv_content_filterensure_buffer_stack(yyscanner);

	/* This block is copied from listserv_content_filter_switch_to_buffer. */
	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*yyg->yy_c_buf_p = yyg->yy_hold_char;
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = yyg->yy_c_buf_p;
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = yyg->yy_n_chars;
		}

	/* Only push if top exists. Otherwise, replace top. */
	if (YY_CURRENT_BUFFER)
		yyg->yy_buffer_stack_top++;
	YY_CURRENT_BUFFER_LVALUE = new_buffer;

	/* copied from listserv_content_filter_switch_to_buffer. */
	listserv_content_filter_load_buffer_state(yyscanner );
	yyg->yy_did_buffer_switch_on_eof = 1;
}

/** Removes and deletes the top of the stack, if present.
 *  The next element becomes the new top.
 *  @param yyscanner The scanner object.
 */
void listserv_content_filterpop_buffer_state (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
	if (!YY_CURRENT_BUFFER)
		return;

	listserv_content_filter_delete_buffer(YY_CURRENT_BUFFER ,yyscanner);
	YY_CURRENT_BUFFER_LVALUE = NULL;
	if (yyg->yy_buffer_stack_top > 0)
		--yyg->yy_buffer_stack_top;

	if (YY_CURRENT_BUFFER) {
		listserv_content_filter_load_buffer_state(yyscanner );
		yyg->yy_did_buffer_switch_on_eof = 1;
	}
}

/* Allocates the stack if it does not exist.
 *  Guarantees space for at least one push.
 */
static void listserv_content_filterensure_buffer_stack (yyscan_t yyscanner)
{
	int num_to_alloc;
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

	if (!yyg->yy_buffer_stack) {

		/* First allocation is just for 2 elements, since we don't know if this
		 * scanner will even need a stack. We use 2 instead of 1 to avoid an
		 * immediate realloc on the next call.
         */
		num_to_alloc = 1;
		yyg->yy_buffer_stack = (struct yy_buffer_state**)listserv_content_filteralloc
								(num_to_alloc * sizeof(struct yy_buffer_state*)
								, yyscanner);
		if ( ! yyg->yy_buffer_stack )
			YY_FATAL_ERROR( "out of dynamic memory in listserv_content_filterensure_buffer_stack()" );
								  
		memset(yyg->yy_buffer_stack, 0, num_to_alloc * sizeof(struct yy_buffer_state*));
				
		yyg->yy_buffer_stack_max = num_to_alloc;
		yyg->yy_buffer_stack_top = 0;
		return;
	}

	if (yyg->yy_buffer_stack_top >= (yyg->yy_buffer_stack_max) - 1){

		/* Increase the buffer to prepare for a possible push. */
		int grow_size = 8 /* arbitrary grow size */;

		num_to_alloc = yyg->yy_buffer_stack_max + grow_size;
		yyg->yy_buffer_stack = (struct yy_buffer_state**)listserv_content_filterrealloc
								(yyg->yy_buffer_stack,
								num_to_alloc * sizeof(struct yy_buffer_state*)
								, yyscanner);
		if ( ! yyg->yy_buffer_stack )
			YY_FATAL_ERROR( "out of dynamic memory in listserv_content_filterensure_buffer_stack()" );

		/* zero only the new slots.*/
		memset(yyg->yy_buffer_stack + yyg->yy_buffer_stack_max, 0, grow_size * sizeof(struct yy_buffer_state*));
		yyg->yy_buffer_stack_max = num_to_alloc;
	}
}

/** Setup the input buffer state to scan directly from a user-specified character buffer.
 * @param base the character buffer
 * @param size the size in bytes of the character buffer
 * @param yyscanner The scanner object.
 * @return the newly allocated buffer state object. 
 */
YY_BUFFER_STATE listserv_content_filter_scan_buffer  (char * base, yy_size_t  size , yyscan_t yyscanner)
{
	YY_BUFFER_STATE b;
    
	if ( size < 2 ||
	     base[size-2] != YY_END_OF_BUFFER_CHAR ||
	     base[size-1] != YY_END_OF_BUFFER_CHAR )
		/* They forgot to leave room for the EOB's. */
		return 0;

	b = (YY_BUFFER_STATE) listserv_content_filteralloc(sizeof( struct yy_buffer_state ) ,yyscanner );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in listserv_content_filter_scan_buffer()" );

	b->yy_buf_size = size - 2;	/* "- 2" to take care of EOB's */
	b->yy_buf_pos = b->yy_ch_buf = base;
	b->yy_is_our_buffer = 0;
	b->yy_input_file = 0;
	b->yy_n_chars = b->yy_buf_size;
	b->yy_is_interactive = 0;
	b->yy_at_bol = 1;
	b->yy_fill_buffer = 0;
	b->yy_buffer_status = YY_BUFFER_NEW;

	listserv_content_filter_switch_to_buffer(b ,yyscanner );

	return b;
}

/** Setup the input buffer state to scan a string. The next call to listserv_content_filterlex() will
 * scan from a @e copy of @a str.
 * @param yystr a NUL-terminated string to scan
 * @param yyscanner The scanner object.
 * @return the newly allocated buffer state object.
 * @note If you want to scan bytes that may contain NUL values, then use
 *       listserv_content_filter_scan_bytes() instead.
 */
YY_BUFFER_STATE listserv_content_filter_scan_string (yyconst char * yystr , yyscan_t yyscanner)
{
    
	return listserv_content_filter_scan_bytes(yystr,strlen(yystr) ,yyscanner);
}

/** Setup the input buffer state to scan the given bytes. The next call to listserv_content_filterlex() will
 * scan from a @e copy of @a bytes.
 * @param bytes the byte buffer to scan
 * @param len the number of bytes in the buffer pointed to by @a bytes.
 * @param yyscanner The scanner object.
 * @return the newly allocated buffer state object.
 */
YY_BUFFER_STATE listserv_content_filter_scan_bytes  (yyconst char * yybytes, int  _yybytes_len , yyscan_t yyscanner)
{
	YY_BUFFER_STATE b;
	char *buf;
	yy_size_t n;
	int i;
    
	/* Get memory for full buffer, including space for trailing EOB's. */
	n = _yybytes_len + 2;
	buf = (char *) listserv_content_filteralloc(n ,yyscanner );
	if ( ! buf )
		YY_FATAL_ERROR( "out of dynamic memory in listserv_content_filter_scan_bytes()" );

	for ( i = 0; i < _yybytes_len; ++i )
		buf[i] = yybytes[i];

	buf[_yybytes_len] = buf[_yybytes_len+1] = YY_END_OF_BUFFER_CHAR;

	b = listserv_content_filter_scan_buffer(buf,n ,yyscanner);
	if ( ! b )
		YY_FATAL_ERROR( "bad buffer in listserv_content_filter_scan_bytes()" );

	/* It's okay to grow etc. this buffer, and we should throw it
	 * away when we're done.
	 */
	b->yy_is_our_buffer = 1;

	return b;
}

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif

static void yy_fatal_error (yyconst char* msg , yyscan_t yyscanner)
{
    	(void) fprintf( stderr, "%s\n", msg );
	exit( YY_EXIT_FAILURE );
}

/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		yytext[yyleng] = yyg->yy_hold_char; \
		yyg->yy_c_buf_p = yytext + yyless_macro_arg; \
		yyg->yy_hold_char = *yyg->yy_c_buf_p; \
		*yyg->yy_c_buf_p = '\0'; \
		yyleng = yyless_macro_arg; \
		} \
	while ( 0 )

/* Accessor  methods (get/set functions) to struct members. */

/** Get the user-defined data for this scanner.
 * @param yyscanner The scanner object.
 */
YY_EXTRA_TYPE listserv_content_filterget_extra  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    return yyextra;
}

/** Get the current column number.
 * @param yyscanner The scanner object.
 */
int listserv_content_filterget_column  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    
        if (! YY_CURRENT_BUFFER)
            return 0;
    
    return yycolumn;
}

/** Get the current token.
 * @param yyscanner The scanner object.
 */

/** Set the user-defined data. This data is never touched by the scanner.
 * @param user_defined The data to be associated with this scanner.
 * @param yyscanner The scanner object.
 */
void listserv_content_filterset_extra (YY_EXTRA_TYPE  user_defined , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    yyextra = user_defined ;
}

/** Set the current column.
 * @param line_number
 * @param yyscanner The scanner object.
 */
void listserv_content_filterset_column (int  column_no , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

        /* column is only valid if an input buffer exists. */
        if (! YY_CURRENT_BUFFER )
           yy_fatal_error( "listserv_content_filterset_column called with no buffer" , yyscanner); 
    
    yycolumn = column_no;
}

/* Accessor methods for yylval and yylloc */

YYSTYPE * listserv_content_filterget_lval  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    return yylval;
}

void listserv_content_filterset_lval (YYSTYPE *  yylval_param , yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    yylval = yylval_param;
}

/* User-visible API */

/* listserv_content_filterlex_init is special because it creates the scanner itself, so it is
 * the ONLY reentrant function that doesn't take the scanner as the last argument.
 * That's why we explicitly handle the declaration, instead of using our macros.
 */

int listserv_content_filterlex_init(yyscan_t* ptr_yy_globals)

{
    if (ptr_yy_globals == NULL){
        errno = EINVAL;
        return 1;
    }

    *ptr_yy_globals = (yyscan_t) listserv_content_filteralloc ( sizeof( struct yyguts_t ), NULL );

    if (*ptr_yy_globals == NULL){
        errno = ENOMEM;
        return 1;
    }

    /* By setting to 0xAA, we expose bugs in yy_init_globals. Leave at 0x00 for releases. */
    memset(*ptr_yy_globals,0x00,sizeof(struct yyguts_t));

    return yy_init_globals ( *ptr_yy_globals );
}

/* listserv_content_filterlex_init_extra has the same functionality as listserv_content_filterlex_init, but follows the
 * convention of taking the scanner as the last argument. Note however, that
 * this is a *pointer* to a scanner, as it will be allocated by this call (and
 * is the reason, too, why this function also must handle its own declaration).
 * The user defined value in the first argument will be available to listserv_content_filteralloc in
 * the yyextra field.
 */

int listserv_content_filterlex_init_extra(YY_EXTRA_TYPE yy_user_defined,yyscan_t* ptr_yy_globals )

{
    struct yyguts_t dummy_yyguts;

    listserv_content_filterset_extra (yy_user_defined, &dummy_yyguts);

    if (ptr_yy_globals == NULL){
        errno = EINVAL;
        return 1;
    }
	
    *ptr_yy_globals = (yyscan_t) listserv_content_filteralloc ( sizeof( struct yyguts_t ), &dummy_yyguts );
	
    if (*ptr_yy_globals == NULL){
        errno = ENOMEM;
        return 1;
    }
    
    /* By setting to 0xAA, we expose bugs in
    yy_init_globals. Leave at 0x00 for releases. */
    memset(*ptr_yy_globals,0x00,sizeof(struct yyguts_t));
    
    listserv_content_filterset_extra (yy_user_defined, *ptr_yy_globals);
    
    return yy_init_globals ( *ptr_yy_globals );
}

static int yy_init_globals (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;
    /* Initialization is the same as for the non-reentrant scanner.
     * This function is called from listserv_content_filterlex_destroy(), so don't allocate here.
     */

    yyg->yy_buffer_stack = 0;
    yyg->yy_buffer_stack_top = 0;
    yyg->yy_buffer_stack_max = 0;
    yyg->yy_c_buf_p = (char *) 0;
    yyg->yy_init = 0;
    yyg->yy_start = 0;

    yyg->yy_start_stack_ptr = 0;
    yyg->yy_start_stack_depth = 0;
    yyg->yy_start_stack =  NULL;

/* Defined in main.c */
#ifdef YY_STDINIT
    yyin = stdin;
    yyout = stdout;
#else
    yyin = (FILE *) 0;
    yyout = (FILE *) 0;
#endif

    /* For future reference: Set errno on error, since we are called by
     * listserv_content_filterlex_init()
     */
    return 0;
}

/* listserv_content_filterlex_destroy is for both reentrant and non-reentrant scanners. */
int listserv_content_filterlex_destroy  (yyscan_t yyscanner)
{
    struct yyguts_t * yyg = (struct yyguts_t*)yyscanner;

    /* Pop the buffer stack, destroying each element. */
	while(YY_CURRENT_BUFFER){
		listserv_content_filter_delete_buffer(YY_CURRENT_BUFFER ,yyscanner );
		YY_CURRENT_BUFFER_LVALUE = NULL;
		listserv_content_filterpop_buffer_state(yyscanner);
	}

	/* Destroy the stack itself. */
	listserv_content_filterfree(yyg->yy_buffer_stack ,yyscanner);
	yyg->yy_buffer_stack = NULL;

    /* Destroy the start condition stack. */
        listserv_content_filterfree(yyg->yy_start_stack ,yyscanner );
        yyg->yy_start_stack = NULL;

    /* Reset the globals. This is important in a non-reentrant scanner so the next time
     * listserv_content_filterlex() is called, initialization will occur. */
    yy_init_globals( yyscanner);

    /* Destroy the main struct (reentrant only). */
    listserv_content_filterfree ( yyscanner , yyscanner );
    yyscanner = NULL;
    return 0;
}

/*
 * Internal utility routines.
 */

#ifndef yytext_ptr
static void yy_flex_strncpy (char* s1, yyconst char * s2, int n , yyscan_t yyscanner)
{
	register int i;
	for ( i = 0; i < n; ++i )
		s1[i] = s2[i];
}
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (yyconst char * s , yyscan_t yyscanner)
{
	register int n;
	for ( n = 0; s[n]; ++n )
		;

	return n;
}
#endif

void *listserv_content_filteralloc (yy_size_t  size , yyscan_t yyscanner)
{
	return (void *) malloc( size );
}

void *listserv_content_filterrealloc  (void * ptr, yy_size_t  size , yyscan_t yyscanner)
{
	/* The cast to (char *) in the following accommodates both
	 * implementations that use char* generic pointers, and those
	 * that use void* generic pointers.  It works with the latter
	 * because both ANSI C and C++ allow castless assignment from
	 * any pointer type to void*, and deal with argument conversions
	 * as though doing an assignment.
	 */
	return (void *) realloc( (char *) ptr, size );
}

void listserv_content_filterfree (void * ptr , yyscan_t yyscanner)
{
	free( (char *) ptr );	/* see listserv_content_filterrealloc() for (char *) cast */
}

#define YYTABLES_NAME "yytables"

#line 176 "content_filter.l"


struct listserv_content_filter**
listserv_getcontent_filter (struct listserv* const l,
                            const char* const listname)
{
  listserv_free_cached_content_filter (l);
  l->cached_content_filter = NULL;
  char *content_filter_template = listserv_getmail_template (l, listname,
							     "CONTENT_FILTER");
  if (content_filter_template == NULL) {
    l->cached_content_filter = malloc (sizeof (struct
					       listserv_content_filter*));
    l->cached_content_filter[0] = NULL;
    return l->cached_content_filter;
  }
  yyscan_t yyscanner;
  listserv_content_filterlex_init (&yyscanner);
  YY_BUFFER_STATE buf =
    listserv_content_filter_scan_string (content_filter_template, yyscanner);
  char** val = ALLOC_A (3 * sizeof (char*));
  int i, j= 1;
  while ((i = listserv_content_filterlex (&val, yyscanner))) {
    l->cached_content_filter = realloc (l->cached_content_filter,
					++j * sizeof (struct
						      listserv_content_filter*));
    struct listserv_content_filter* c = malloc (sizeof (struct
							listserv_content_filter));
    l->cached_content_filter[j - 2] = c;
    c->header = val[0];
    c->value = val[1];
    c->text = val[2];
    c->action = i;
  }
  l->cached_content_filter[j - 1] = NULL;
  FREE_A (val);
  listserv_content_filter_delete_buffer (buf, yyscanner);
  listserv_content_filterlex_destroy (yyscanner);
  return l->cached_content_filter;
}

